      COMPLEX*16 FUNCTION JAWsubsubd(Qs,Ps,m12,m22,m32)
*------------------------------------------------------
* m12 and m42 in the limit
      IMPLICIT NONE!
      REAL*8 Qs,Ps,rm12,rm22,rm32
      REAL*8 eps,pi,zet2,A,Ps13,B1,aC1
      COMPLEX*16 ieps,im,C1,sC1,D1,sD1,E,B2,sC2
      COMPLEX*16 m12,m22,m32,P,dt,zlp,zlm
      COMPLEX*16 XSPENZ,JAW0,JAW1,JAW2
      PARAMETER (eps =1d-30)
      PARAMETER (pi  =3.1415926535897932384626433832795028d0)
      PARAMETER (zet2=1.6449340668482264364724151666460251d0)
*
*     m1=mbt, m2=mtp, m3=mw, m4=mel
*
* javsub=jav-(1+Qs/(mbt^2+Ts))*c0(0,-mel^2,Qs;mw,mel,0)
* c0(0,-mel^2,Qs;mw,mel,0)=1/Qs*(-LOG(Qs/m42)*CQLOG(m32/(Qs+m32-ieps))
*     -1d0/2*CQLOG(m32/(Qs+m32-ieps))**2-XSPENZ(m32/(Qs+m32-ieps))+zet2)
* javsubsub=javsub-(mtp^2+Qs)/Ps*c0(-mtp^2,-mbt^2,Qs;mw,mbt,0)
*                                  C02(p12,p22,Qs,m12,m22,m32)  
      rm12=DREAL(m12)
      rm22=DREAL(m22)
      rm32=DREAL(m32)
      P=Qs+m32
      ieps=DCMPLX(0d0,eps)
      im  =DCMPLX(0d0,1d0)
*
       JAW0=1/Ps*(
     & +2*DREAL(LOG(P/rm32))*LOG(-Ps/(Qs+rm22))
     & -(2*LOG((rm22-rm32)/rm32)+1d0/2*LOG(-rm32/Ps))*im*pi
*
     & +LOG((Qs+rm22)**2/rm22/(-Ps))*LOG(-(rm22-rm32+ieps)/rm32)
     & -XSPENZ(-(Qs+rm32-ieps)/(rm22-rm32))
     & -XSPENZ(-(Qs+rm32+ieps)/(rm22-rm32))
     & +XSPENZ(-(Ps-rm32-ieps)/rm32)
     & -XSPENZ(-(rm22-rm32+ieps)/rm32)
     & -10*zet2  )            
* The first part:
      A=Ps+rm22
      Ps13=Ps+rm32
      B1=A*Ps13-2*rm32*Ps
      C1=(Ps-rm32)**2+4*rm22*ieps
      sC1=SQRT(C1)
      D1=A**2-2*B1+C1
      sD1=SQRT(D1)
      E=sD1*sC1-C1+B1
      JAW1=1d0/2/Ps*(
     &  +LOG((Ps-ieps)/rm32)
     &  *(LOG(2*C1*(C1-B1-sC1*sD1))-LOG(B1**2-A**2*C1))
     &  +zet2
     &  +(Ps-rm32)/sC1*(
     &    +XSPENZ(E*(Ps13+sC1)/(Ps13-sC1)/(B1+A*sC1))
     &    -XSPENZ(E*(Ps13-sC1)/(Ps13+sC1)/(B1-A*sC1))
     &    +XSPENZ(E/(B1-A*sC1))-XSPENZ(E/(B1+A*sC1)))
     &              )
* The second part:
      B2=-(A*(1-ieps/Ps)*rm22+(Ps-rm22)*(rm32-ieps))
      sC2=(1-ieps/Ps)*rm22-(rm32-ieps)
      IF(DREAL(sC2).GE.0d0) THEN
       B2=-A*sC2-2*Ps*(rm32-ieps)
       dt =2*(rm32-ieps)*(rm22*(1-ieps/Ps)+Ps-rm32)/(1-ieps/Ps)/sC2
       zlm=+sC2/(rm22*(1-ieps/Ps)+Ps-rm32)
       zlp=-sC2/(rm32-ieps)
*
       JAW2=+1d0/2/Ps*(
     & +(+2*LOG(-1-ieps)-LOG(rm32/(-Ps))
     &   -2*LOG((-Ps*(1-ieps/Ps))/sC2)
     &  )*LOG(-(A**2*sC2**2-B2**2)/2/sC2**3/dt)
     &   +(-LOG(2*sC2/(zlm*zlp*dt))
     &     +LOG(1-zlp/zlm)-LOG(1-zlp))*LOG(1-1/zlp)
     &   +(-LOG(2*sC2/(zlm*zlp*dt))
     &     +LOG(1-zlm/zlp)-LOG(1-zlm))*LOG(1-1/zlm)
     &     +1d0/2*LOG(1-1/zlp)**2
     &     +1d0/2*LOG(1-1/zlm)**2
     &     -XSPENZ((1-zlp)/(zlm-zlp))
     &     -XSPENZ((1-zlm)/(zlp-zlm))
     &     +XSPENZ(-zlp/(zlm-zlp))
     &     +XSPENZ(-zlm/(zlp-zlm))
     &     -XSPENZ(-zlp/(1-zlp))
     &     -XSPENZ(-zlm/(1-zlm))
     &   -2*XSPENZ(1/(1-zlm))
     &     +2*zet2       )
      ELSE
       print*,'non-foreseen situation, sC2=',sC2
       stop
      ENDIF
      JAWsubsubd=JAW0+JAW1+JAW2
      RETURN
      END
