************************************************************************
*   iqed     = 0   without QED corrections
*              1   with 
*              2   ISR
*              3   IFI
*              4   FSR
*              5   [IFI+FSR]
*
*   iew      = 0   without Weak corrections
*              1   with
*
*   iqcd     = 0   without QCD corrections
*              1   with
*
*   iborn    = 0   Born + 1-loop
*              1   Born
*
*   gfscheme = 0   alpha(0) calculation scheme
*              1   GF
*              2   GF prime
*                
*   ilin     = 0   without linearization
*              1   with
*
*   ifgg    = -1   ffgg = 0
*              0          zoro
*              1          [zoro+coeff*ff_gg]
*              2          [zoro/(1d0 - coeff*ff_gg)]
*
*   ihard    = 1   (1spr,2spr) integration for hard
*              2   (4d,5d) integration
*
*   isetup   = 0   SANC input [PDG 2006]            CPC 177 (2007) 623
*              1   Les Houches Workshop (2005)      [hep-ph/0604120]
*              2   Tevatron-for-LHC Workshop (2006) [arXiv:0705.3251]
*              3   Les Houches Workshop (2007)      [arXiv:0803.0678]
*
* Types of the 1-loop corrections
* for the processes with pid=1-6,19-24:
* ------------------------------------
* | iqed | iew  | iqcd | corrections |
* ------------------------------------
* |  1   |  0   |  0   |   QED       |
* |  0   |  1   |  0   |   Weak      |
* |  0   |  0   |  1   |   QCD       |
* |  1   |  1   |  0   |   EW        |
* |  1   |  0   |  1   |   QED+QCD   |
* |  0   |  1   |  1   |   Weak+QCD  |
* |  1   |  1   |  1   |   EW+QCD    |
* ------------------------------------
************************************************************************

      iqed = 1
      iew = 1
      iqcd = 0
      iborn = 0
      gfscheme = 0
      ilin = 1
      ifgg = 1
      ihard = 1
      isetup = 0

************************************************************************
* Table of the processes
* [pid - Process IDentification number]:
* --------------------------------------------------------
* | pid | SANC     | Process                             |
* |     | notation |                                     |
* --------------------------------------------------------
* |  1  | 13141112 | anti-up + dn -> en   + el^-         |
* |  2  | 14131211 | anti-dn + up -> el^+ + en           |
* |  3  | 13141516 | anti-up + dn -> mn   + mo^-         |
* |  4  | 14131615 | anti-dn + up -> mo^+ + mn           |
* |  5  | 13141920 | anti-up + dn -> tn   + ta^-         |
* |  6  | 14132019 | anti-dn + up -> ta^+ + tn           |
* | 19  | 21221112 | anti-tp -> anti-bt + en      + el^- |
* | 20  | 22211211 |      tp ->      bt + el^+    + en   |
* | 21  | 21221516 | anti-tp -> anti-bt + mn      + mo^- |
* | 22  | 22211615 |      tp ->      bt + mo^+    + mn   |
* | 23  | 21221314 | anti-tp -> anti-bt + anti-up + dn   |
* | 24  | 22211413 |      tp ->      bt + anti-dn + up   |
* --------------------------------------------------------
************************************************************************

      pid = 1

************************************************************************
* Kinematic parameters
************************************************************************

      sq = 40d0
      ome = 1d-5            ! reaction
*      ome = 1d-2            ! decay

************************************************************************
* VEGAS parameters
************************************************************************

      nrdm = 12345

* Born
      nc1( 1) = 100 000     ! reaction
*      nc1( 1) = 500 000     ! decay
      it1( 1) = 10
      it2( 1) = 10
* virt (Weak)
      nc1( 2) = 10 000      ! reaction
*      nc1( 2) = 100 000     ! decay
      it1( 2) = 10
      it2( 2) = 10
* virt+soft (QED)
      nc1( 3) = 100 000     ! reaction
*      nc1( 3) = 500 000     ! decay
      it1( 3) = 10
      it2( 3) = 10
* brdq (QED)
      nc1( 4) = 100 000     ! reaction
      it1( 4) = 10
      it2( 4) = 10
* hard (QED), (1spr,2spr)
      nc1( 5) = 100 000     ! reaction
*      nc1( 5) = 1 000 000   ! decay
      it1( 5) = 10
      it2( 5) = 10
* hard (QED), (4d,5d)
      nc1( 6) = 1 000 000   ! reaction
*      nc1( 6) = 10 000 000  ! decay
      it1( 6) = 10
      it2( 6) = 10
* virt+soft (QCD)
      nc1( 7) = 10 000      ! reaction
*      nc1( 7) = 500 000     ! decay
      it1( 7) = 10
      it2( 7) = 10
* brdq (QCD)
      nc1( 8) = 100 000     ! reaction
      it1( 8) = 10
      it2( 8) = 10
* hard (QCD), (1spr,2spr)
      nc1( 9) = 100 000     ! reaction
*      nc1( 9) = 1 000 000   ! decay
      it1( 9) = 10
      it2( 9) = 10
* hard (QCD), (4d,5d)
      nc1(10) = 1 000 000   ! reaction
*      nc1(10) = 10 000 000  ! decay
      it1(10) = 10
      it2(10) = 10
