************************************************************************
* File (cc-qcd_br_1413_1615.f) created on Wed Dec  3 15:58:39 MSK 2008.
************************************************************************
* This is the FORTRAN module (cc_qcd_br_1413_1615) to calculate Born
* cross section and QCD virtual corrections 
* for dn + up -> mo + mn process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_br_1413_1615 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 costh
      real*8 ln1sdn,ln1sup

      real*8 kappaw
      complex*16 chiws,chiwsc

      cmw2 = mw2
      s = -qs
      t = -ts
      u = -us

      cosf = (u-t)/(s-mmo**2)
      sinf = dsqrt(1d0-cosf**2)

      kappaw = gf*rwm2/(sqrt(2d0)*4d0*pi)/alpha
      chiws = 4d0*kappaw*s/(s-cmw2)
      chiwsc = dconjg(chiws)

      born=
     & +chiws*chiwsc*cosf*pi*alpha**2*(1d0/6*mmo**2/s**2-1d0/12*mmo**4/s
     & **3-1d0/12/s)
     & +chiws*chiwsc*cosf**2*pi*alpha**2*(-1d0/8*mmo**2/s**2+1d0/8*mmo**
     & 4/s**3-1d0/24*mmo**6/s**4+1d0/24/s)
     & +chiws*chiwsc*pi*alpha**2*(-1d0/24*mmo**2/s**2-1d0/24*mmo**4/s**3
     & +1d0/24*mmo**6/s**4+1d0/24/s)

      born = born*conhc
      virt = 0d0
      soft = 0d0
      hard = 0d0

      if (iborn.eq.1) return

      ln1sdn  = log(s/mdn**2)-1d0
      ln1sup  = log(s/mup**2)-1d0

      softvirt=
     & +born/pi*alphas*cf*(-1d0/2)
     & +ln1sup*born/pi*alphas*cf*(3d0/4)
     & +ln1sup*log(4*omega**2/s)*born/pi*alphas*cf*(1d0/2)
     & +ln1sdn*born/pi*alphas*cf*(3d0/4)
     & +ln1sdn*log(4*omega**2/s)*born/pi*alphas*cf*(1d0/2)
     & +ddilog(1d0)*born/pi*alphas*cf*(2)

      soft = softvirt

      return
      end
************************************************************************
* This is the FORTRAN module (cc_qcd_ha_1413_1615_1spr) to calculate hard
* gluon Bremsstrahlung for dn + up -> mo + mn process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_ha_1413_1615_1spr (s,spr,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 kappaw
      real*8 ln1sdn,ln1sup
      complex*16 chiwspr,chiwsprc

      cmw2 = mw2

      kappaw = gf*rwm2/(sqrt(2d0)*4d0*pi)/alpha
      chiwspr = 4d0*kappaw*spr/(spr-cmw2)
      chiwsprc = dconjg(chiwspr)

      ln1sdn = log(s/mdn**2)-1d0
      ln1sup = log(s/mup**2)-1d0

      hard=
     & +ln1sup*chiwspr*chiwsprc*alpha**2*alphas*cf*(-1d0/12*mmo**2/s**2/
     & spr-1d0/6*mmo**2/s**2/(s-spr)
     & -1d0/12*mmo**2/s/spr**2+1d0/18*mmo**6/s**4/spr+1d0/18*mmo**6/s**4
     & /(s-spr)
     & +1d0/18*mmo**6/s**3/spr**2+1d0/36*mmo**6/s**2/spr**3+1d0/36*mmo**
     & 6/s/spr**4-1d0/18/s**2+1d0/18/s/spr+1d0/9/s/(s-spr))
     & +ln1sdn*chiwspr*chiwsprc*alpha**2*alphas*cf*(-1d0/12*mmo**2/s**2/
     & spr-1d0/6*mmo**2/s**2/(s-spr)
     & -1d0/12*mmo**2/s/spr**2+1d0/18*mmo**6/s**4/spr+1d0/18*mmo**6/s**4
     & /(s-spr)
     & +1d0/18*mmo**6/s**3/spr**2+1d0/36*mmo**6/s**2/spr**3+1d0/36*mmo**
     & 6/s/spr**4-1d0/18/s**2+1d0/18/s/spr+1d0/9/s/(s-spr))

      hard = hard*conhc

      return
      end
