************************************************************************
* File (cc-qcd_ha_2122_1516.f) created on Wed Jun  3 20:17:54 MSD 2009.
************************************************************************
* This is the FORTRAN module (cc_qcd_ha_2122_1516) to calculate differential
* hard gluon Bremsstrahlung for anti-tp -> anti-bt + mn + mo.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_ha_2122_1516 (s,spr,ph4,costh4,costh5,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 sq,sqspr
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph4,cosph4,sinph4,costh4,sinth4,costh5,sinth5

      real*8 sqrtlstpbt,isqrtlstpbt
      complex*16 propwspr,propiwspr,propwsprc
      real*8 iz1bt,iz2tp,iz3mn,iz4mo

      cmw2 = mw2

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph4 = dcos(ph4)
      sinph4 = dsin(ph4)
      sinth4 = dsqrt(1d0-costh4**2)
      sinth5 = dsqrt(1d0-costh5**2)

      propiwspr = (cmw2-spr)
      propwspr = 1d0/propiwspr
      propwsprc = dconjg(propwspr)
      sqrtlstpbt = sqrt(s**2-2d0*s*(rtpm2+rbtm2)+(rtpm2-rbtm2)**2)
      isqrtlstpbt = 1d0/sqrtlstpbt

      p1p2=
     & -1d0/2*mtp**2+1d0/2*s

      p1p3=
     & +sinph4*sinth4*sinth5*(mtp**2-s)*(1d0/4*sq*sqspr/s)
     & +costh4*costh5*(mtp**2-s)*(-1d0/8-1d0/8/s*spr)
     & +costh4*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & +costh5*(mtp**2-s)*(-1d0/8+1d0/8/s*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s+1d0/8*spr

      p1p4=
     & +sinph4*sinth4*sinth5*(mtp**2-s)*(-1d0/4*sq*sqspr/s)
     & +costh4*costh5*(mtp**2-s)*(1d0/8+1d0/8/s*spr)
     & +costh4*(-1d0/8*mtp**2/s*spr+1d0/8*mtp**2-1d0/8*s+1d0/8*spr)
     & +costh5*(mtp**2-s)*(-1d0/8+1d0/8/s*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2+1d0/8*s+1d0/8*spr

      p1p5=
     & +costh5*(mtp**2-s)*(1d0/4-1d0/4/s*spr)
     & +1d0/4*mtp**2/s*spr-1d0/4*mtp**2+1d0/4*s-1d0/4*spr

      p2p3=
     & +sinph4*sinth4*sinth5*(mtp**2-s)*(1d0/4*sq*sqspr/s)
     & +costh4*costh5*(mtp**2-s)*(-1d0/8-1d0/8/s*spr)
     & +costh4*(1d0/8*mtp**2/s*spr-1d0/8*mtp**2-1d0/8*s+1d0/8*spr)
     & +costh5*(mtp**2-s)*(-1d0/8+1d0/8/s*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2-1d0/8*s-1d0/8*spr

      p2p4=
     & +sinph4*sinth4*sinth5*(mtp**2-s)*(-1d0/4*sq*sqspr/s)
     & +costh4*costh5*(mtp**2-s)*(1d0/8+1d0/8/s*spr)
     & +costh4*(-1d0/8*mtp**2/s*spr+1d0/8*mtp**2+1d0/8*s-1d0/8*spr)
     & +costh5*(mtp**2-s)*(-1d0/8+1d0/8/s*spr)
     & -1d0/8*mtp**2/s*spr-1d0/8*mtp**2-1d0/8*s-1d0/8*spr

      p2p5=
     & +costh5*(mtp**2-s)*(1d0/4-1d0/4/s*spr)
     & +1d0/4*mtp**2/s*spr-1d0/4*mtp**2-1d0/4*s+1d0/4*spr

      p3p4=
     & -1d0/2*spr

      p3p5=
     & +costh4*(-1d0/4*s+1d0/4*spr)
     & -1d0/4*s+1d0/4*spr

      p4p5=
     & +costh4*(1d0/4*s-1d0/4*spr)
     & -1d0/4*s+1d0/4*spr

      iz1bt=
     & +1d0/(mbt**2/s+1d0/4*sqrtlstpbt**2*sinth5**2/s**2)/(s-spr)*(-1d0/
     & 2+1d0/2*mtp**2/s-1d0/2*mbt**2/s+1d0/2*sqrtlstpbt*costh5/s)

      iz2tp=
     & +1d0/(mtp**2/s+1d0/4*sqrtlstpbt**2*sinth5**2/s**2)/(s-spr)*(1d0/2
     & +1d0/2*mtp**2/s-1d0/2*mbt**2/s+1d0/2*sqrtlstpbt*costh5/s)

      hard=
     & +iz1bt**2*propwspr*propwsprc*(mtp**2-s)/pi**5*alphas*gf**2*mw**4/
     & mtp**3*mbt**2/s*(s-spr)*cf*(-1d0/32*p1p3*p2p4-1d0/32*p2p4*p3p5)
     & +iz1bt*propwspr*propwsprc*(mtp**2-s)/pi**5*alphas*gf**2*mw**4/mtp
     & **3/s*(s-spr)*cf*(1d0/64*p1p3*p1p4+1d0/64*p1p3*p2p4+1d0/64*p2p4*p
     & 3p5)
     & +iz1bt*propwspr*propwsprc*(mtp**2-s)/pi**5*alphas*gf**2*mw**4/mtp
     & **3/s*cf*(-1d0/16*p1p2*p1p3*p2p4+1d0/32*p1p2*p1p3*p4p5-1d0/32*p1p
     & 2*p2p4*p3p5)
     & +iz2tp**2*propwspr*propwsprc*(mtp**2-s)/pi**5*alphas*gf**2*mw**4/
     & mtp/s*(s-spr)*cf*(-1d0/32*p1p3*p2p4+1d0/32*p1p3*p4p5)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alphas*gf**2*mw**4/mtp
     & **3/s*(s-spr)*cf*(-1d0/64*p1p3*p2p4+1d0/64*p1p3*p4p5-1d0/64*p2p3*
     & p2p4)
     & +iz2tp*propwspr*propwsprc*(mtp**2-s)/pi**5*alphas*gf**2*mw**4/mtp
     & **3/s*cf*(1d0/16*p1p2*p1p3*p2p4-1d0/32*p1p2*p1p3*p4p5+1d0/32*p1p2
     & *p2p4*p3p5)

      return
      end
