************************************************************************
* File (cc_br_2122_1314.f) created on Tue May 26 22:37:08 MSD 2009.
************************************************************************
* This is the FORTRAN module (cc_bo_2122_1314) to calculate EW
* integrated Born width for anti-tp -> anti-bt + up + dn decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_bo_2122_1314 (s,born)
      implicit none!
      include 's2n_declare.h'

      complex*16 propws,propiws,propwsc

      cmw2 = mw2

      propiws = (cmw2-s)
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      born=
     & +propws*propwsc/pi**3*gf**2*mw**4*(1d0/16/mtp**3*s**3-3d0/32/mtp*
     & s**2+1d0/32*mtp**3)

      return
      end
************************************************************************
* This is the FORTRAN module (cc_br_2122_1314) to calculate EW Born
* width and soft photon Bremsstrahlung
* for anti-tp -> anti-bt + up + dn decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_br_2122_1314 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 qw,softvirtisr,softvirtfsr,softvirtifi
      complex*16 propws,propiws,propwsc

      cmw2 = mw2
      qw   = 1d0

      s = -qs
      t = -ts
      u = -us

      cosf = (u-t)/(mtp**2-s)
      sinf = dsqrt(1d0-cosf**2)

      propiws = (cmw2-s)
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      betaf = mtp**2-s

      born=
     & +propws*propwsc/pi**3*gf**2*mw**4*(-3d0/16/mtp**3*u**2+3d0/16/mtp
     & *u)

      born = born*betaf/2d0
      virt = 0d0
      soft = 0d0
      hard = 0d0

      if (iborn.eq.1) return


      softvirtisr=
     & +born/pi*alpha*qw**2*(1)
     & +born/pi*alpha*qtp**2*(3d0/4)
     & +born/pi*alpha*qbt**2*(3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qtp**2*(-3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qbt**2*(-3d0/4)
     & +log(-1+mtp**2/s)*born/pi*alpha*qbt**2*(1)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qw*qbt*(1)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qtp*qbt*(-2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qtp*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qbt*(1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qtp**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qbt**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*log(-1+mtp**2/s)*born/pi*alpha*qbt**2*(1)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*mbt**2)*born/pi*alpha*(-1d
     & 0/18)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp*qbt*(
     & 1+1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp**2*(-
     & 1d0/2-1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qbt**2*(1
     & d0/2)
     & +log(1d0/mtp**2*mbt**2)*born/pi*alpha*(-1d0/12)
     & +log(1d0/mtp**2*mbt**2)*log(-1+mtp**2/s)*born/pi*alpha*(1d0/9)
     & +log(1d0/mtp**2*mbt**2)**2*born/pi*alpha*(-1d0/12)
     & +log(1d0/mtp**2*mbt**2)*log(1d0/mtp**2*s)*born/pi*alpha*(1d0/18)
     & +log(1d0/mtp**2*s)*born/pi*alpha*qtp**2*(-1d0/2-1d0/(mtp**2-s)*s)
     & +log(1d0/mtp**2*s)*born/pi*alpha*qbt**2*(1d0/2)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qtp*(1+2*1d0
     & /(mtp**2-s)*s)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qbt*(1)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qtp*qbt*(-4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qtp*(3d0/4+3d0/2*1d0/(mtp*
     & *2-s)*s)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qbt*(1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qtp*qbt*(-2)
     & +ddilog(1d0/mtp**2*s)*born/pi*alpha*qw*qtp*(1+2*1d0/(mtp**2-s)*s)
     & +ddilog(1d0/mtp**2*s)*born/pi*alpha*qtp*qbt*(-2)
     & +ddilog(1d0)*born/pi*alpha*qw*qtp*(-1-2*1d0/(mtp**2-s)*s)
     & +ddilog(1d0)*born/pi*alpha*qw*qbt*(1)

      softvirtfsr=
     & +born/pi*alpha*qw**2*(1)
     & +born/pi*alpha*qup**2*(3d0/4)
     & +born/pi*alpha*qdn**2*(3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qup**2*(-3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qdn**2*(-3d0/4)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qtp*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qbt*(1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qup**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qdn**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*log(mup**2/mtp**2)*born/pi*alpha*qup**2*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(mdn**2/mtp**2)*born/pi*alpha*qdn**2*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qup*qdn*(
     & 1)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qup*qtp*(
     & 1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qup*qbt*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qdn*qtp*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qdn*qbt*(
     & 1d0/2)
     & +log(mup**2/mtp**2)*born/pi*alpha*qup**2*(-3d0/4)
     & +log(mup**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qup**2*(1d0/2
     & )
     & +log(mdn**2/mtp**2)*born/pi*alpha*qdn**2*(-3d0/4)
     & +log(mdn**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qdn**2*(1d0/2
     & )
     & +log(1d0/mtp**2*s)*born/pi*alpha*qup**2*(1d0/2)
     & +log(1d0/mtp**2*s)*born/pi*alpha*qdn**2*(1d0/2)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qup*(-1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qdn*(1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qup*qdn*(-1)
     & +ddilog(1d0)*born/pi*alpha*qw*qup*(-1)
     & +ddilog(1d0)*born/pi*alpha*qw*qdn*(1)

      softvirtifi=
     & +born/pi*alpha*qw**2*(-2)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qw*qbt*(-1)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qup*qbt*(1)
     & +log(-1+mtp**2/s)**2*born/pi*alpha*qdn*qbt*(-1)
     & +log(1-1d0/mtp**2*t)**2*born/pi*alpha*qup*qtp*(-1)
     & +log(1-1d0/mtp**2*u)**2*born/pi*alpha*qdn*qtp*(1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qtp*(1)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qw*qbt*(-1)
     & +log(4*omega**2/mtp**2)*log(-1+mtp**2/s)*born/pi*alpha*qtp*qbt*(1
     & )
     & +log(4*omega**2/mtp**2)*log(-1+mtp**2/s)*born/pi*alpha*qbt**2*(-1
     & )
     & +log(4*omega**2/mtp**2)*log(1-1d0/mtp**2*t)*born/pi*alpha*qup*qtp
     & *(1)
     & +log(4*omega**2/mtp**2)*log(1-1d0/mtp**2*u)*born/pi*alpha*qdn*qtp
     & *(-1)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qup*qtp*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qup*qbt*(
     & 1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qdn*qtp*(
     & 1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qdn*qbt*(
     & -1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp*qbt*(
     & -1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qtp**2*(1
     & d0/2+1d0/(mtp**2-s)*s)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*qbt**2*(-
     & 1d0/2)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*t)*born/pi*alpha*qdn*qbt*(
     & 1)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*u)*born/pi*alpha*qup*qbt*(
     & -1)
     & +log(1d0/mtp**2*mbt**2)**2*born/pi*alpha*(1d0/12)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qtp*(-1-2*1d
     & 0/(mtp**2-s)*s)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qw*qbt*(-1)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qup*qbt*(1)
     & +log(1d0/mtp**2*s)*log(-1+mtp**2/s)*born/pi*alpha*qdn*qbt*(-1)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qup*(1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qdn*(-1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qtp*(-3d0/4-3d0/2*1d0/(mtp
     & **2-s)*s)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qw*qbt*(-1d0/4)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qup*qtp*(-1d0/2)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qup*qbt*(1d0/2)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qdn*qtp*(1d0/2)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qdn*qbt*(-1d0/2)
     & +log(1d0/mtp**2*t)**2*born/pi*alpha*qdn*qbt*(-1d0/2)
     & +log(1d0/mtp**2*u)**2*born/pi*alpha*qup*qbt*(1d0/2)
     & +ddilog(1d0/mtp**2*s)*born/pi*alpha*qw*qtp*(-1-2*1d0/(mtp**2-s)*s
     & )
     & +ddilog(1d0/mtp**2*t)*born/pi*alpha*qup*qtp*(-1)
     & +ddilog(mbt**2/u)*born/pi*alpha*qup*qbt*(-1)
     & +ddilog(-1d0/t*u)*born/pi*alpha*qdn*qbt*(-1)
     & +ddilog(-t/u)*born/pi*alpha*qup*qbt*(1)
     & +ddilog(1/(mtp**2-t)*mtp**2-1/(mtp**2-t)*s-1/(mtp**2-t)*t)*born/p
     & i*alpha*qup*qtp*(-1)
     & +ddilog(-1/(mtp**2-t)*t)*born/pi*alpha*qup*qtp*(-1)
     & +ddilog(1/(mtp**2-u)*t)*born/pi*alpha*qdn*qtp*(1)
     & +ddilog(1d0)*born/pi*alpha*qw*qup*(1)
     & +ddilog(1d0)*born/pi*alpha*qw*qdn*(-1)
     & +ddilog(1d0)*born/pi*alpha*qw*qtp*(1+2*1d0/(mtp**2-s)*s)
     & +ddilog(1d0)*born/pi*alpha*qw*qbt*(-1)
     & +ddilog(1d0)*born/pi*alpha*qup*qtp*(-1)
     & +ddilog(1d0)*born/pi*alpha*qup*qbt*(-2)
     & +ddilog(1d0)*born/pi*alpha*qdn*qtp*(1)
     & +ddilog(1d0)*born/pi*alpha*qdn*qbt*(2)

      if (iqed.eq.1) then
         soft = softvirtisr+softvirtfsr+softvirtifi
      elseif(iqed.eq.2) then
         soft = softvirtisr
      elseif(iqed.eq.3) then
         soft = softvirtifi
      elseif(iqed.eq.4) then
         soft = softvirtfsr
      endif

      return
      end
************************************************************************
* This is the FORTRAN module (cc_ha_2122_1314_1spr) to calculate hard
* photon Bremsstrahlung for anti-tp -> anti-bt + up + dn decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ha_2122_1314_1spr (s,spr,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 qw,mds,mdspr,md2spr,mds2spr
      complex*16 propiwspr,propwspr,propwsprc
      complex*16 propws,propiws,propwsc

      cmw2 = mw2
      qw   = 1d0

      propiws = (cmw2-s)
      propws = 1d0/propiws
      propwsc = dconjg(propws)
      mds = propws*propwsc
      propiwspr = (cmw2-spr)
      propwspr = 1d0/propiwspr
      propwsprc = dconjg(propwspr)
      mdspr = propwspr*propwsprc
      md2spr = propwspr + propwsprc
      mds2spr = propws*propwsprc + propwspr*propwsc

      hardisr=
     & +mdspr/pi**4*alpha*g**4*qw*qtp*(-3d0/1024*(mtp**2-s)/mtp**3*s+1d0
     & /256*(mtp**2-s)/mtp**3*(s-spr)
     & +3d0/2048*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/2048*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & -1d0/512*(mtp**2-s)**2/mtp**3+1d0/3072*(mtp**2-s)**3/mtp**3/s**3*
     & (s-spr)**2-1d0/2048*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/1024*(mtp**2-s)**3/mtp**3/s)+mdspr/pi**4*alpha*g**4*qw*qbt*(
     & 1d0/512*(mtp**2-s)/mtp**3/s*(s-spr)**2+3d0/1024*(mtp**2-s)/mtp**3
     & *s-5d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & +1d0/2048*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/2048*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & +1d0/512*(mtp**2-s)**2/mtp**3-1d0/3072*(mtp**2-s)**3/mtp**3/s**3*
     & (s-spr)**2+1d0/2048*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/1024*(mtp**2-s)**3/mtp**3/s)
     & +mdspr/pi**4*alpha*g**4*qw**2*(-3d0/2048*(mtp**2-s)**2/mtp**3/s**
     & 2*(s-spr)**2+1d0/512*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+3d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/1024*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2+7d0/6144*(mtp
     & **2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/1024*(mtp**2-s)**3/mtp**3/s-1d0/1024*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +mdspr/pi**4*alpha*g**4*qtp*qbt*(1d0/512*(mtp**2-s)/mtp**3*(s-spr
     & )
     & +1d0/1024*(mtp**2-s)**2/mtp**3/s*(s-spr))
     & +mdspr/pi**4*alpha*g**4*qtp**2*(-1d0/1024*(mtp**2-s)/mtp**3/s*(s-
     & spr)**2-3d0/1024*(mtp**2-s)/mtp**3*s+3d0/2048*(mtp**2-s)/mtp**3*(
     & s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3/s*(s-spr)-3d0/1024*(mtp**2-s)**2/m
     & tp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/mtp**3-1d0/1024*(mtp**2-s)
     & **3/mtp**3/(s-spr))
     & +mdspr/pi**4*alpha*g**4*qbt**2*(-1d0/1024*(mtp**2-s)/mtp**3/s*(s-
     & spr)**2-3d0/1024*(mtp**2-s)/mtp**3*s+5d0/2048*(mtp**2-s)/mtp**3*(
     & s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/1024*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1-1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qw*qbt*(-3d0/512*(mtp
     & **2-s)/mtp**3*s+1d0/256*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/512*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/512*(mtp**2-s)**2/mtp
     & **3-1d0/512*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1-1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qtp*qbt*(3d0/512*(mtp
     & **2-s)/mtp**3*s-1d0/256*(mtp**2-s)/mtp**3*(s-spr)
     & +3d0/512*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/512*(mtp**2-s)**2/mtp**3+1d0/512*(mtp**2-s)**3/mtp**3/(s-spr
     & ))
     & +log(1-1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qbt**2*(1d0/1024*(mtp
     & **2-s)/mtp**3*(s-spr)
     & +3d0/1024/mtp**3*s*(s-spr)
     & -1d0/512/mtp**3*(s-spr)**2)+log(1d0/mtp**2*mbt**2)*mdspr/pi**4*al
     & pha*g**4*qw*qbt*(3d0/1024*(mtp**2-s)/mtp**3*s-1d0/512*(mtp**2-s)/
     & mtp**3*(s-spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3+1d0/1024*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mtp**2*mbt**2)*mdspr/pi**4*alpha*g**4*qtp*qbt*(-3d0/1024
     & *(mtp**2-s)/mtp**3*s+1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/1024*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*mbt**2)*mdspr/pi**4*alpha*g**4*qbt**2*(-1d0/2048*
     & (mtp**2-s)/mtp**3*(s-spr)
     & -3d0/2048/mtp**3*s*(s-spr)+1d0/1024/mtp**3*(s-spr)**2)
     & +log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qw*qtp*(1d0/256*(mtp**2
     & -s)/mtp**3*s-3d0/512*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & +1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & -5d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+3d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/1024*(mtp**2-s)**3/mtp**3/(s-spr)
     & +1d0/256/mtp**3*s*(s-spr)
     & -3d0/1024/mtp**3*s**2)+log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*q
     & w*qbt*(3d0/1024*(mtp**2-s)/mtp**3*s-1d0/512*(mtp**2-s)/mtp**3*(s-
     & spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3+1d0/1024*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qtp*qbt*(5d0/1024*(mtp*
     & *2-s)/mtp**3*s+1d0/512*(mtp**2-s)**2/mtp**3+3d0/1024/mtp**3*s**2)
     & 
     & +log(1d0/mtp**2*s)*mdspr/pi**4*alpha*g**4*qtp**2*(-5d0/1024*(mtp*
     & *2-s)/mtp**3*s+1d0/2048*(mtp**2-s)/mtp**3*(s-spr)
     & -1d0/512*(mtp**2-s)**2/mtp**3+3d0/2048/mtp**3*s*(s-spr)
     & -3d0/1024/mtp**3*s**2-1d0/1024/mtp**3*(s-spr)**2)+log(1d0/mtp**2*
     & s)*mdspr/pi**4*alpha*g**4*qbt**2*(-1d0/2048*(mtp**2-s)/mtp**3*(s-
     & spr)
     & -3d0/2048/mtp**3*s*(s-spr)+1d0/1024/mtp**3*(s-spr)**2)

      hardfsr=
     & +mds/pi**4*alpha*g**4*qw*qup*(3d0/1024*(mtp**2-s)**2/mtp**3/s**2*
     & (s-spr)**2-9d0/2048*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & +1d0/512*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2-5d0/2048*(mtp**2-s)
     & **3/mtp**3/s**2*(s-spr))
     & +mds/pi**4*alpha*g**4*qw*qdn*(-3d0/1024*(mtp**2-s)**2/mtp**3/s**2
     & *(s-spr)**2+9d0/2048*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & -1d0/512*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2+5d0/2048*(mtp**2-s)
     & **3/mtp**3/s**2*(s-spr))
     & +mds/pi**4*alpha*g**4*qw**2*(-3d0/2048*(mtp**2-s)**2/mtp**3/s**2*
     & (s-spr)**2+1d0/512*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+3d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/1024*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2+7d0/6144*(mtp
     & **2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/1024*(mtp**2-s)**3/mtp**3/s-1d0/1024*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +mds/pi**4*alpha*g**4*qup*qdn*(3d0/1024*(mtp**2-s)**2/mtp**3/s**2
     & *(s-spr)**2-3d0/1024*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & +1d0/512*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2-1d0/512*(mtp**2-s)*
     & *3/mtp**3/s**2*(s-spr))
     & +mds/pi**4*alpha*g**4*qup**2*(-3d0/2048*(mtp**2-s)**2/mtp**3/s**2
     & *(s-spr)**2-3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3-1d0/1024*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2+1d0/2048*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/1024*(mtp**2-s)**3/mtp**3/s-1d0/1024*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +mds/pi**4*alpha*g**4*qdn**2*(-3d0/2048*(mtp**2-s)**2/mtp**3/s**2
     & *(s-spr)**2-3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3-1d0/1024*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2+1d0/2048*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/1024*(mtp**2-s)**3/mtp**3/s-1d0/1024*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +log(1d0/mup**2*spr)*mds/pi**4*alpha*g**4*qw*qup*(3d0/1024*(mtp**
     & 2-s)**2/mtp**3*s/(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3-1d0/1024*(mtp**2-s)**3/mtp**3/s+1d
     & 0/1024*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mup**2*spr)*mds/pi**4*alpha*g**4*qup*qdn*(3d0/1024*(mtp*
     & *2-s)**2/mtp**3*s/(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3-1d0/1024*(mtp**2-s)**3/mtp**3/s+1d
     & 0/1024*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mup**2*spr)*mds/pi**4*alpha*g**4*qup**2*(3d0/2048*(mtp**
     & 2-s)**2/mtp**3/s*(s-spr)
     & +1d0/2048*(mtp**2-s)**3/mtp**3/s**2*(s-spr))
     & +log(1d0/mdn**2*spr)*mds/pi**4*alpha*g**4*qw*qdn*(-3d0/1024*(mtp*
     & *2-s)**2/mtp**3*s/(s-spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3+1d0/1024*(mtp**2-s)**3/mtp**3/s-1d
     & 0/1024*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mdn**2*spr)*mds/pi**4*alpha*g**4*qup*qdn*(3d0/1024*(mtp*
     & *2-s)**2/mtp**3*s/(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3-1d0/1024*(mtp**2-s)**3/mtp**3/s+1d
     & 0/1024*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mdn**2*spr)*mds/pi**4*alpha*g**4*qdn**2*(3d0/2048*(mtp**
     & 2-s)**2/mtp**3/s*(s-spr)
     & +1d0/2048*(mtp**2-s)**3/mtp**3/s**2*(s-spr))

      hardifi=
     & +1d0/pi**4*alpha*g**4*qw*qup*mds2spr*(-3d0/2048*(mtp**2-s)**2/mtp
     & **3/s**2*(s-spr)**2+9d0/4096*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & -1d0/1024*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2+5d0/4096*(mtp**2-s
     & )**3/mtp**3/s**2*(s-spr))
     & +1d0/pi**4*alpha*g**4*qw*qdn*mds2spr*(3d0/2048*(mtp**2-s)**2/mtp*
     & *3/s**2*(s-spr)**2-9d0/4096*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & +1d0/1024*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2-5d0/4096*(mtp**2-s
     & )**3/mtp**3/s**2*(s-spr))
     & +1d0/pi**4*alpha*g**4*qw*qtp*mds2spr*(3d0/2048*(mtp**2-s)/mtp**3*
     & s-1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/4096*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2+1d0/4096*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & +1d0/1024*(mtp**2-s)**2/mtp**3-1d0/6144*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2+1d0/4096*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/2048*(mtp**2-s)**3/mtp**3/s)
     & +1d0/pi**4*alpha*g**4*qw*qbt*mds2spr*(-1d0/1024*(mtp**2-s)/mtp**3
     & /s*(s-spr)**2-3d0/2048*(mtp**2-s)/mtp**3*s+5d0/2048*(mtp**2-s)/mt
     & p**3*(s-spr)
     & -1d0/4096*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2+1d0/4096*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3+1d0/6144*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2-1d0/4096*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/2048*(mtp**2-s)**3/mtp**3/s)+1d0/pi**4*alpha*g**4*qw**2*mds2
     & spr*(3d0/2048*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/512*(mtp**
     & 2-s)**2/mtp**3/s*(s-spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3+1d0/1024*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2-7d0/6144*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/1024*(mtp**2-s)**3/mtp**3/s+1d0/1024*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +1d0/pi**4*alpha*g**4*qup*qtp*mds2spr*(-3d0/512*(mtp**2-s)/mtp**3
     & *s+5d0/1024*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & +3d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & +3d0/4096*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/4096*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & +1d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & +1d0/6144*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2-1d0/4096*(mtp**2-s
     & )**3/mtp**3/s**2*(s-spr)
     & +1d0/2048*(mtp**2-s)**3/mtp**3/s-5d0/6144*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +1d0/pi**4*alpha*g**4*qup*qbt*mds2spr*(1d0/1024*(mtp**2-s)/mtp**3
     & /s*(s-spr)**2-1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & +1d0/4096*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2-1d0/4096*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & +3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3-1d0/6144*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2+1d0/4096*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/2048*(mtp**2-s)**3/mtp**3/s+5d0/6144*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +1d0/pi**4*alpha*g**4*qdn*qtp*mds2spr*(1d0/1024*(mtp**2-s)/mtp**3
     & *s**2/(s-spr)
     & -3d0/2048*(mtp**2-s)/mtp**3*(s-spr)-3d0/4096*(mtp**2-s)**2/mtp**3
     & /s**2*(s-spr)**2+1d0/4096*(mtp**2-s)**2/mtp**3/s*(s-spr)
     & +5d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3-1d0/6144*(mtp**2-s)**3/mtp**3/s**3
     & *(s-spr)**2+1d0/4096*(mtp**2-s)**3/mtp**3/s**2*(s-spr)
     & -1d0/2048*(mtp**2-s)**3/mtp**3/s+5d0/6144*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +1d0/pi**4*alpha*g**4*qdn*qbt*mds2spr*(-1d0/1024*(mtp**2-s)/mtp**
     & 3/s*(s-spr)**2-3d0/1024*(mtp**2-s)/mtp**3*s+7d0/2048*(mtp**2-s)/m
     & tp**3*(s-spr)
     & -1d0/4096*(mtp**2-s)**2/mtp**3/s**2*(s-spr)**2+1d0/4096*(mtp**2-s
     & )**2/mtp**3/s*(s-spr)
     & -9d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+3d0/1024*(mtp**2-s)**2/m
     & tp**3+1d0/6144*(mtp**2-s)**3/mtp**3/s**3*(s-spr)**2-1d0/4096*(mtp
     & **2-s)**3/mtp**3/s**2*(s-spr)
     & +1d0/2048*(mtp**2-s)**3/mtp**3/s-5d0/6144*(mtp**2-s)**3/mtp**3/(s
     & -spr))
     & +log(1-1d0/mtp**2*s)/pi**4*alpha*g**4*qw*qbt*mds2spr*(3d0/1024*(m
     & tp**2-s)/mtp**3*s-1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3+1d0/1024*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1-1d0/mtp**2*s)/pi**4*alpha*g**4*qup*qbt*mds2spr*(-3d0/1024*
     & (mtp**2-s)/mtp**3*s+1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/1024*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1-1d0/mtp**2*s)/pi**4*alpha*g**4*qdn*qbt*mds2spr*(3d0/1024*(
     & mtp**2-s)/mtp**3*s-1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & +3d0/1024*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3+1d0/1024*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mup**2*spr)/pi**4*alpha*g**4*qw*qup*mds2spr*(-3d0/2048*(
     & mtp**2-s)**2/mtp**3*s/(s-spr)
     & +3d0/2048*(mtp**2-s)**2/mtp**3+1d0/2048*(mtp**2-s)**3/mtp**3/s-1d
     & 0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mup**2*spr)/pi**4*alpha*g**4*qup*qtp*mds2spr*(3d0/2048*(
     & mtp**2-s)**2/mtp**3*s/(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3-1d0/2048*(mtp**2-s)**3/mtp**3/s+1d
     & 0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mup**2*spr)/pi**4*alpha*g**4*qup*qbt*mds2spr*(-3d0/2048*
     & (mtp**2-s)**2/mtp**3*s/(s-spr)
     & +3d0/2048*(mtp**2-s)**2/mtp**3+1d0/2048*(mtp**2-s)**3/mtp**3/s-1d
     & 0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mdn**2*spr)/pi**4*alpha*g**4*qw*qdn*mds2spr*(3d0/2048*(m
     & tp**2-s)**2/mtp**3*s/(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3-1d0/2048*(mtp**2-s)**3/mtp**3/s+1d
     & 0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mdn**2*spr)/pi**4*alpha*g**4*qdn*qtp*mds2spr*(-3d0/2048*
     & (mtp**2-s)**2/mtp**3*s/(s-spr)
     & +3d0/2048*(mtp**2-s)**2/mtp**3+1d0/2048*(mtp**2-s)**3/mtp**3/s-1d
     & 0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mdn**2*spr)/pi**4*alpha*g**4*qdn*qbt*mds2spr*(3d0/2048*(
     & mtp**2-s)**2/mtp**3*s/(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3-1d0/2048*(mtp**2-s)**3/mtp**3/s+1d
     & 0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*mbt**2)/pi**4*alpha*g**4*qw*qbt*mds2spr*(-3d0/204
     & 8*(mtp**2-s)/mtp**3*s+1d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/2048*(mtp**2-s)**2/m
     & tp**3-1d0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*mbt**2)/pi**4*alpha*g**4*qup*qbt*mds2spr*(3d0/204
     & 8*(mtp**2-s)/mtp**3*s-1d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & +3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3+1d0/2048*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mtp**2*mbt**2)/pi**4*alpha*g**4*qdn*qbt*mds2spr*(-3d0/20
     & 48*(mtp**2-s)/mtp**3*s+1d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/2048*(mtp**2-s)**2/m
     & tp**3-1d0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qw*qtp*mds2spr*(-1d0/512*(mtp
     & **2-s)/mtp**3*s+3d0/1024*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & -1d0/1024*(mtp**2-s)/mtp**3*(s-spr)+5d0/2048*(mtp**2-s)**2/mtp**3
     & *s/(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3+1d0/2048*(mtp**2-s)**3/mtp**3/(s-s
     & pr)
     & -1d0/512/mtp**3*s*(s-spr)+3d0/2048/mtp**3*s**2)
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qw*qbt*mds2spr*(-3d0/2048*(mt
     & p**2-s)/mtp**3*s+1d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/2048*(mtp**2-s)**2/m
     & tp**3-1d0/2048*(mtp**2-s)**3/mtp**3/(s-spr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qup*qtp*mds2spr*(-3d0/1024*(m
     & tp**2-s)/mtp**3*s+3d0/1024*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & +1d0/512*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/1024*(mtp**2-s)**2/m
     & tp**3-1d0/2048*(mtp**2-s)**3/mtp**3/(s-spr)
     & +3d0/1024/mtp**3*s*(s-spr)
     & -3d0/512/mtp**3*s**2+5d0/1024/mtp**3*s**3/(s-spr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qup*qbt*mds2spr*(3d0/2048*(mt
     & p**2-s)/mtp**3*s-1d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & +3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)
     & -1d0/2048*(mtp**2-s)**2/mtp**3+1d0/2048*(mtp**2-s)**3/mtp**3/(s-s
     & pr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qdn*qtp*mds2spr*(-3d0/1024*(m
     & tp**2-s)/mtp**3*s+3d0/1024*(mtp**2-s)/mtp**3*s**2/(s-spr)
     & -1d0/2048*(mtp**2-s)/mtp**3*(s-spr)+3d0/2048*(mtp**2-s)**2/mtp**3
     & *s/(s-spr)
     & -1d0/1024*(mtp**2-s)**2/mtp**3+1d0/2048*(mtp**2-s)**3/mtp**3/(s-s
     & pr)
     & -3d0/2048/mtp**3*s*(s-spr)+1d0/1024/mtp**3*s**3/(s-spr))
     & +log(1d0/mtp**2*s)/pi**4*alpha*g**4*qdn*qbt*mds2spr*(-3d0/2048*(m
     & tp**2-s)/mtp**3*s+1d0/1024*(mtp**2-s)/mtp**3*(s-spr)
     & -3d0/2048*(mtp**2-s)**2/mtp**3*s/(s-spr)+1d0/2048*(mtp**2-s)**2/m
     & tp**3-1d0/2048*(mtp**2-s)**3/mtp**3/(s-spr))

      if (iqed.eq.1) then
         hard = hardisr+hardfsr+hardifi
      elseif(iqed.eq.2) then
         hard = hardisr
      elseif(iqed.eq.3) then
         hard = hardifi
      elseif(iqed.eq.4) then
         hard = hardfsr
      endif

      return
      end
