************************************************************************
* File (cc_ff_1413_2019.F) created on Wed Dec  3 14:47:31 MSK 2008.
************************************************************************
* This is the FORTRAN module (cc_ff_1413_2019) to calculate 1-loop EW
* form factors for the dn + up -> ta + tn process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ff_1413_2019 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_qed_ll,ff_qed_ld,ff_qed_rd
      complex*16 ff_ew_ll,ff_ew_ld,ff_ew_rd

      real*8 a0fw,a0fz,a0fh,a0fta
      complex*16 b0ptazta,b0ptahta,b0ptacw
      complex*16 b0fqswz,b0fqswh,b0fqswc,b0ftawc,b0ftazta,b0fcwta,b0fts
     & tac,b0ftscc,b0ftahta,b0fqstac,b0fqscc
      complex*16 c0tacqswcz,c0tacqsztaw,c0tacqshtaw,c0tactstazc,c0tacts
     & cwc,c0tacustazc,c0ccqswcz,c0cctscwta,c0cctsczc,c0ccuscwta,c0tacqs
     & tazc,c0tacqsctaw,c0ccqsczc
      complex*16 b0d2tazta
      complex*16 d0cctacqsuswczta,d0cctacqsuszcwc,d0ccctaqstswczc,d0ccc
     & taqstszcwta
      complex*16 javsubqstsctaw,javsubqsusctaw
      real*8 sdet3ictaqs,sdet3ictats,sdet3ictaus
      real*8 invftaw
      complex*16 propwqs,propiwqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      cmw2 = mw2

      propiwqs = (cmw2+qs)
      propwqs = 1d0/propiwqs
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      a0fta = log(rtam2/thmu2) - 1d0
      b0ptazta = b0p(-rtam2,zm2,tam2)
      b0ptahta = b0p(-rtam2,hm2,tam2)
      b0ptacw = b0p(-rtam2,cm2,wm2)
      b0fqswz = b0f(qs,thmu2,wm2,zm2)
      b0fqswh = b0f(qs,thmu2,wm2,hm2)
      b0fqswc = b0f(qs,thmu2,mw2,cm2)
      b0ftawc = b0f(-rtam2,thmu2,wm2,cm2)
      b0ftazta = b0f(-rtam2,thmu2,zm2,tam2)
      b0fcwta = b0f(0d0,thmu2,wm2,tam2)
      b0ftstac = b0f(ts,thmu2,tam2,cm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      b0ftahta = b0f(-rtam2,thmu2,hm2,tam2)
      b0fqstac = b0f(qs,thmu2,tam2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      c0tacqswcz = c01(-rtam2,1d-6,qs,wm2,cm2,zm2)
      c0tacqsztaw = c01(-rtam2,1d-6,qs,zm2,tam2,wm2)
      c0tacqshtaw = c01(-rtam2,1d-6,qs,hm2,tam2,wm2)
      c0tactstazc = c01(-rtam2,0d0,ts,tam2,zm2,cm2)
      c0tactscwc = c01(-rtam2,0d0,ts,cm2,wm2,cm2)
      c0tacustazc = c01(-rtam2,0d0,us,tam2,zm2,cm2)
      c0ccqswcz = c01(0d0,0d0,qs,wm2,cm2,zm2)
      c0cctscwta = c01(0d0,0d0,ts,cm2,wm2,tam2)
      c0cctsczc = c01(0d0,0d0,ts,cm2,zm2,cm2)
      c0ccuscwta = c01(0d0,0d0,us,cm2,wm2,tam2)
      c0tacqstazc = c01(-rtam2,0d0,qs,tam2,zm2,cm2)
      c0tacqsctaw = dreal(c01(-rtam2,0d0,qs,cm2,tam2,mw2))
      c0ccqsczc = c01(0d0,0d0,qs,cm2,zm2,cm2)
      b0d2tazta = b0d2(-rtam2,thmu2,zm2,tam2)
      d0cctacqsuswczta =
     & d0(0d0,0d0,rtam2,0d0,-qs,-us,rwm2,0d0,rzm2,rtam2)
      d0cctacqsuszcwc =
     & d0(0d0,0d0,rtam2,0d0,-qs,-us,rzm2,0d0,rwm2,0d0)
      d0ccctaqstswczc =
     & d0(0d0,0d0,0d0,rtam2,-qs,-ts,rwm2,0d0,rzm2,0d0)
      d0ccctaqstszcwta =
     & d0(0d0,0d0,0d0,rtam2,-qs,-ts,rzm2,0d0,rwm2,rtam2)
      javsubqstsctaw = javsub(qs,ts,cm2,tam2,mw2)
      javsubqsusctaw = javsub(qs,us,cm2,tam2,mw2)
      sdet3ictaqs = 1d0/(qs+(mta)**2)
      sdet3ictats = 1d0/(ts+(mta)**2)
      sdet3ictaus = 1d0/(us+(mta)**2)
      invftaw = 1d0/(1d0-rtam2/rwm2)

      ff_ew_ll =
     & +mta**2*(-1d0/8*vpata/mw**2+1d0/8*vmata/mw**2+1d0/16/mw**2-1d0/8*
     & b0d2tazta/ctw**2*vmata**2)
     & +propwqs*a0fw*(-1d0/12/ctw**2*mw**2-5*mw**2+3*mw**4/mh**2-1d0/12*
     & mh**2)
     & +propwqs*a0fz*(1d0/12/ctw**4*mw**2+3d0/2/ctw**4*mw**4/mh**2+2d0/3
     & /ctw**2*mw**2-2*mw**2)
     & +propwqs*a0fh*(-1d0/12/qs*mh**4+1d0/2*mh**2)
     & +propwqs*b0fqswz*(1d0/12/ctw**4*mw**2+4d0/3/ctw**2*mw**2-4*ctw**2
     & *mw**2-17d0/3*mw**2)
     & +propwqs*b0fqswh*(-1d0/12/qs*mh**4+mw**2-1d0/3*mh**2)
     & +propwqs*b0fqswc*(4*ctw**2*mw**2-4*mw**2)
     & +propwqs*(1d0/ctw**4*mw**4/mh**2-1d0/6/ctw**2*mw**2-mw**2*zmwzwbo
     & s-64d0/9*mw**2+2*mw**4/mh**2-1d0/6*mh**2)
     & +propiwqs*mta**2*(2*ctw**2*qup*qta/ts/us-2*qup*qta/ts/us)
     & +propiwqs*sdet3ictaqs*mta**2*(2*ctw**2*qup*qta/ts+2*ctw**2*qup*qt
     & a/us-2*ctw**2*qdn*qta/qs-2*qup*qta/ts-2*qup*qta/us+2*qdn*qta/qs)
     & +propiwqs*sdet3ictaqs*mta**4*(-8*ctw**2*qup*qta/ts/us+8*qup*qta/t
     & s/us)
     & +propiwqs*sdet3ictaqs**2*mta**4*(-8*ctw**2*qup*qta/ts-8*ctw**2*qu
     & p*qta/us+8*qup*qta/ts+8*qup*qta/us)
     & +propiwqs*sdet3ictaqs**2*c0tacqswcz*mta**4*(-2/ctw**4*vpadn*vpatn
     & /ts*mw**2-2/ctw**4*vpadn*vpatn/us*mw**2)
     & +propiwqs*sdet3ictaqs**2*c0tacqsztaw*mta**4*(-2/ctw**2*vpaup*vpat
     & a/ts*mw**2-2/ctw**2*vpaup*vpata/us*mw**2)
     & +propiwqs*sdet3ictaqs**2*c0tacqsztaw*mta**6*(2/ctw**2*vpaup*vpata
     & /ts+2/ctw**2*vpaup*vpata/us)
     & +propiwqs*sdet3ictaqs**2*a0fta*mta**4*(-8*stw**2*qup*qta/ts-8*stw
     & **2*qup*qta/us)
     & +propiwqs*sdet3ictaqs**2*b0ftawc*mta**4*(2/ctw**2*vpadn*vpatn/ts+
     & 2/ctw**2*vpadn*vpatn/us)
     & +propiwqs*sdet3ictaqs**2*b0ftazta*mta**4*(2/ctw**2*vpaup*vpata/ts
     & +2/ctw**2*vpaup*vpata/us)
     & +propiwqs*sdet3ictaqs**2*b0fqswz*mta**4*(-2/ctw**2*vpaup*vpata/ts
     & -2/ctw**2*vpaup*vpata/us-2/ctw**2*vpadn*vpatn/ts-2/ctw**2*vpadn*v
     & patn/us)
     & +propiwqs*sdet3ictaqs**2*b0fqswc*mta**4*(8*ctw**2*qup*qta/ts+8*ct
     & w**2*qup*qta/us-8*qup*qta/ts-8*qup*qta/us)
     & +propiwqs*sdet3ictaqs*c0tacqswcz*mta**2*(-1d0/2/ctw**4*vpaup*vpat
     & n/qs*mw**2+1d0/2/ctw**4*vpadn*vpatn/ts*mw**2+1d0/2/ctw**4*vpadn*v
     & patn/us*mw**2+1d0/ctw**2*vpadn*vpatn/ts*mw**2+1d0/ctw**2*vpadn*vp
     & atn/us*mw**2)
     & +propiwqs*sdet3ictaqs*c0tacqswcz*mta**4*(-2/ctw**4*vpadn*vpatn/ts
     & /us*mw**2-1d0/ctw**2*vpadn*vpatn/ts-1d0/ctw**2*vpadn*vpatn/us)
     & +propiwqs*sdet3ictaqs*c0tacqswcz*(-1d0/2/ctw**4*vpaup*vpatn*mw**2
     & )
     & +propiwqs*sdet3ictaqs*c0tacqsztaw*mta**2*(1d0/ctw**4*vpaup*vpata/
     & ts*mw**2+1d0/ctw**4*vpaup*vpata/us*mw**2+1d0/2/ctw**2*vpaup*vpata
     & /ts*mw**2+1d0/2/ctw**2*vpaup*vpata/us*mw**2-1d0/2/ctw**2*vpadn*vp
     & ata/qs*mw**2)
     & +propiwqs*sdet3ictaqs*c0tacqsztaw*mta**4*(-2/ctw**2*vpaup*vpata/t
     & s/us*mw**2-5d0/2/ctw**2*vpaup*vpata/ts-5d0/2/ctw**2*vpaup*vpata/u
     & s)
     & +propiwqs*sdet3ictaqs*c0tacqsztaw*mta**6*(2/ctw**2*vpaup*vpata/ts
     & /us)
     & +propiwqs*sdet3ictaqs*c0tacqsztaw*(1d0/2/ctw**2*vpadn*vpata*ts+1d
     & 0/2/ctw**2*vpadn*vpata*us-1d0/2/ctw**2*vpadn*vpata*mw**2)
     & +propiwqs*sdet3ictaqs*a0fz*mta**2*(1d0/ctw**2*vpadn*vpatn/ts+1d0/
     & ctw**2*vpadn*vpatn/us)
     & +propiwqs*sdet3ictaqs*a0fta*mta**2*(2*stw**2*qup*qta/ts+2*stw**2*
     & qup*qta/us)
     & +propiwqs*sdet3ictaqs*a0fta*mta**4*(-8*stw**2*qup*qta/ts/us)
     & +propiwqs*sdet3ictaqs*b0ftawc*mta**2*(1d0/2/ctw**2*vpaup*vpatn/qs
     & -1d0/2/ctw**2*vpadn*vpatn/ts-1d0/2/ctw**2*vpadn*vpatn/us)
     & +propiwqs*sdet3ictaqs*b0ftawc*mta**4*(2/ctw**2*vpadn*vpatn/ts/us)
     & +propiwqs*sdet3ictaqs*b0ftawc*(1d0/2/ctw**2*vpaup*vpatn)
     & +propiwqs*sdet3ictaqs*b0ftazta*mta**2*(-1d0/2/ctw**2*vpaup*vpata/
     & ts-1d0/2/ctw**2*vpaup*vpata/us+1d0/2/ctw**2*vpadn*vpata/qs)
     & +propiwqs*sdet3ictaqs*b0ftazta*mta**4*(2/ctw**2*vpaup*vpata/ts/us
     & )
     & +propiwqs*sdet3ictaqs*b0ftazta*(1d0/2/ctw**2*vpadn*vpata)
     & +propiwqs*sdet3ictaqs*b0fqswz*mta**2*(-1d0/2/ctw**2*vpaup*vpatn/q
     & s+3d0/2/ctw**2*vpaup*vpata/ts+3d0/2/ctw**2*vpaup*vpata/us+3d0/2/c
     & tw**2*vpadn*vpatn/ts+3d0/2/ctw**2*vpadn*vpatn/us-1d0/2/ctw**2*vpa
     & dn*vpata/qs)
     & +propiwqs*sdet3ictaqs*b0fqswz*mta**4*(-2/ctw**2*vpaup*vpata/ts/us
     & -2/ctw**2*vpadn*vpatn/ts/us)
     & +propiwqs*sdet3ictaqs*b0fqswz*(-1d0/2/ctw**2*vpaup*vpatn-1d0/2/ct
     & w**2*vpadn*vpata)
     & +propiwqs*sdet3ictaqs*b0fqswc*mta**2*(-6*ctw**2*qup*qta/ts-6*ctw*
     & *2*qup*qta/us+2*ctw**2*qdn*qta/qs+6*qup*qta/ts+6*qup*qta/us-2*qdn
     & *qta/qs)
     & +propiwqs*sdet3ictaqs*b0fqswc*mta**4*(8*ctw**2*qup*qta/ts/us-8*qu
     & p*qta/ts/us)
     & +propiwqs*sdet3ictaqs*b0fqswc*(2*ctw**2*qdn*qta-2*qdn*qta)
     & +propiwqs*sdet3ictaqs*b0fcwta*mta**2*(-1d0/ctw**2*vpaup*vpata/ts-
     & 1d0/ctw**2*vpaup*vpata/us+4*ctw**2*qup*qta/ts+4*ctw**2*qup*qta/us
     & -4*qup*qta/ts-4*qup*qta/us)
     & +propiwqs*sdet3ictaqs*(-2*ctw**2*qdn*qta+2*qdn*qta)
     & +propiwqs*sdet3ictats*mta**2*(-2*ctw**2*qdn*qta/us+2*qdn*qta/us)
     & +propiwqs*sdet3ictats*c0tactstazc*mta**2*(1d0/2/ctw**4*vpadn*vpat
     & a/us*mw**2)
     & +propiwqs*sdet3ictats*c0tactscwc*mta**2*(1d0/2/ctw**2*vpaup*vpatn
     & /us*mw**2)
     & +propiwqs*sdet3ictats*a0fta*mta**2*(-2*stw**2*qdn*qta/us)
     & +propiwqs*sdet3ictats*b0ftawc*mta**2*(1d0/2/ctw**2*vpaup*vpatn/us
     & )
     & +propiwqs*sdet3ictats*b0ftazta*mta**2*(1d0/2/ctw**2*vpadn*vpata/u
     & s)
     & +propiwqs*sdet3ictats*b0ftstac*mta**2*(-1d0/2/ctw**2*vpadn*vpata/
     & us+2*ctw**2*qdn*qta/us-2*qdn*qta/us)
     & +propiwqs*sdet3ictats*b0ftscc*mta**2*(-1d0/2/ctw**2*vpaup*vpatn/u
     & s)
     & +propiwqs*d0cctacqsuswczta*mta**2*(-1d0/4/ctw**4*vpaup*vmata/qs*m
     & w**2+1d0/2/ctw**2*vpaup*vpata+1d0/4/ctw**2*vpaup*vmata/qs*mw**2+1
     & d0/4/ctw**2*vpaup*vmata)
     & +propiwqs*d0cctacqsuswczta*mta**4*(1d0/4/ctw**2*vpaup*vmata/qs/us
     & *mw**2+1d0/4/ctw**2*vpaup*vmata/us)
     & +propiwqs*d0cctacqsuswczta*(1d0/2/ctw**2*vpaup*vpata*us)
     & +propiwqs*d0cctacqsuszcwc*(1d0/2/ctw**2*vpadn*vpatn*us)
     & +propiwqs*d0ccctaqstswczc*mta**2*(-1d0/4/ctw**6*vpaup*vpatn/us**2
     & *mw**4-1d0/4/ctw**4*vpaup*vpatn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vp
     & atn/qs*mw**2+1d0/2/ctw**4*vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2
     & *vpaup*vpatn/qs/us*mw**4+1d0/4/ctw**2*vpaup*vpatn/qs*mw**2-1d0/4/
     & ctw**2*vpaup*vpatn*ts**2/us**2+1d0/4/ctw**2*vpaup*vpatn/us**2*mw*
     & *4+1d0/4/ctw**2*vpaup*vpatn/us*mw**2)
     & +propiwqs*d0ccctaqstswczc*mta**4*(1d0/4/ctw**2*vpaup*vpatn/qs/us*
     & *2*mw**4+1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2)
     & +propiwqs*d0ccctaqstswczc*(-1d0/4/ctw**6*vpaup*vpatn*ts/us**2*mw*
     & *4-1d0/2/ctw**4*vpaup*vpatn*ts/us**2*mw**4+1d0/2/ctw**4*vpaup*vpa
     & tn*ts**2/us**2*mw**2-1d0/2/ctw**4*vpaup*vpatn/us*mw**4-1d0/4/ctw*
     & *2*vpaup*vpatn*ts/us**2*mw**4-1d0/4/ctw**2*vpaup*vpatn*ts+1d0/2/c
     & tw**2*vpaup*vpatn*ts**2/us**2*mw**2-1d0/4/ctw**2*vpaup*vpatn*ts**
     & 3/us**2)
     & +propiwqs*d0ccctaqstszcwta*mta**2*(1d0/4/ctw**6*vpadn*vpata/qs/us
     & *mw**4+1d0/4/ctw**6*vpadn*vpata/us**2*mw**4-1d0/4/ctw**4*vpadn*vp
     & ata/qs/us*mw**4+1d0/4/ctw**4*vpadn*vpata/qs*mw**2+1d0/2/ctw**4*vp
     & adn*vpata*ts/us**2*mw**2+1d0/2/ctw**4*vpadn*vpata/us*mw**2-1d0/4/
     & ctw**4*vpadn*vmata/qs*mw**2-1d0/4/ctw**4*vpadn*vmata/us*mw**2-1d0
     & /4/ctw**2*vpadn*vpata/qs*mw**2+1d0/ctw**2*vpadn*vpata*ts/us**2*mw
     & **2-1d0/4/ctw**2*vpadn*vpata*ts/us-3d0/4/ctw**2*vpadn*vpata*ts**2
     & /us**2-1d0/4/ctw**2*vpadn*vpata/us**2*mw**4+1d0/4/ctw**2*vpadn*vp
     & ata/us*mw**2-1d0/4/ctw**2*vpadn*vpata+1d0/4/ctw**2*vpadn*vmata/qs
     & *mw**2+1d0/4/ctw**2*vpadn*vmata*ts/us-1d0/4/ctw**2*vpadn*vmata/us
     & *mw**2)
     & +propiwqs*d0ccctaqstszcwta*mta**4*(1d0/4/ctw**6*vpadn*vpata/qs/us
     & **2*mw**4+1d0/4/ctw**4*vpadn*vpata/qs/us*mw**2-1d0/4/ctw**4*vpadn
     & *vmata/qs/us*mw**2-3d0/4/ctw**2*vpadn*vpata*ts/us**2+1d0/2/ctw**2
     & *vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/us+1d0/4/ctw**2
     & *vpadn*vmata/us)
     & +propiwqs*d0ccctaqstszcwta*mta**6*(-1d0/4/ctw**2*vpadn*vpata/us**
     & 2)
     & +propiwqs*d0ccctaqstszcwta*(-1d0/4/ctw**6*vpadn*vpata*ts/us**2*mw
     & **4-1d0/2/ctw**4*vpadn*vpata*ts/us**2*mw**4+1d0/2/ctw**4*vpadn*vp
     & ata*ts**2/us**2*mw**2-1d0/2/ctw**4*vpadn*vpata/us*mw**4-1d0/4/ctw
     & **2*vpadn*vpata*ts/us**2*mw**4-1d0/4/ctw**2*vpadn*vpata*ts+1d0/2/
     & ctw**2*vpadn*vpata*ts**2/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata*ts*
     & *3/us**2)
     & +propiwqs*c0tacqswcz*mta**2*(1d0/2/ctw**4*vpadn*vpatn/ts/us*mw**2
     & +1d0/4/ctw**2*vpaup*vpatn/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn/us
     & +1d0/ctw**2*vpadn*vpatn/ts/us*mw**2)
     & +propiwqs*c0tacqswcz*mta**4*(1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2+1d0/4/ctw**2*vpaup*vpatn/qs/us-1d0/ctw**2*vpadn*vpatn/ts/us)
     & +propiwqs*c0tacqswcz*(1d0/2/ctw**4*vpaup*vpatn/qs*mw**2-1d0/4/ctw
     & **4*vpaup*vpatn*ts/us**2*mw**2-1d0/4/ctw**4*vpaup*vpatn/us*mw**2-
     & 1d0/4/ctw**2*vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn*
     & ts**2/us**2-1d0/4/ctw**2*vpaup*vpatn/us*mw**2+1d0/4/ctw**2*vpaup*
     & vpatn-1d0/2/ctw**2*vpadn*vpatn)
     & +propiwqs*c0tacqsztaw*mta**2*(1d0/ctw**4*vpaup*vpata/ts/us*mw**2+
     & 1d0/4/ctw**4*vpadn*vpata/us**2*mw**2+1d0/2/ctw**2*vpaup*vpata/ts/
     & us*mw**2+1d0/4/ctw**2*vpaup*vmata/us+1d0/4/ctw**2*vpadn*vpata*ts/
     & us**2+1d0/2/ctw**2*vpadn*vpata/us-1d0/4/ctw**2*vpadn*vmata/us)
     & +propiwqs*c0tacqsztaw*mta**4*(1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2-5d0/2/ctw**2*vpaup*vpata/ts/us+1d0/4/ctw**2*vpaup*vmata/qs/u
     & s+1d0/4/ctw**2*vpadn*vpata/qs/us-1d0/4/ctw**2*vpadn*vmata/qs/us)
     & +propiwqs*c0tacqsztaw*(-1d0/4/ctw**4*vpadn*vpata*ts/us**2*mw**2-1
     & d0/4/ctw**4*vpadn*vpata/us*mw**2-1d0/2/ctw**2*vpaup*vpata+1d0/2/c
     & tw**2*vpadn*vpata/qs*mw**2-1d0/4/ctw**2*vpadn*vpata*ts/us**2*mw**
     & 2+1d0/4/ctw**2*vpadn*vpata*ts**2/us**2-1d0/4/ctw**2*vpadn*vpata/u
     & s*mw**2+3d0/4/ctw**2*vpadn*vpata)
     & +propiwqs*c0tactstazc*mta**2*(1d0/4/ctw**4*vpadn*vpata/qs/us*mw**
     & 2+1d0/4/ctw**2*vpadn*vpata/qs-1d0/2/ctw**2*vpadn*vpata*ts/us**2+1
     & d0/4/ctw**2*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vmata/qs+1
     & d0/4/ctw**2*vpadn*vmata/us)
     & +propiwqs*c0tactstazc*mta**4*(-1d0/4/ctw**2*vpadn*vpata/us**2)
     & +propiwqs*c0tactstazc*(1d0/4/ctw**4*vpadn*vpata*ts/us**2*mw**2+1d
     & 0/4/ctw**2*vpadn*vpata*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpata*ts
     & /us-1d0/4/ctw**2*vpadn*vpata*ts**2/us**2)
     & +propiwqs*c0tactscwc*mta**2*(1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2
     & +1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpatn/qs
     & -1d0/4/ctw**2*vpaup*vpatn*ts/us**2)
     & +propiwqs*c0tactscwc*(1d0/4/ctw**4*vpaup*vpatn*ts/us**2*mw**2+1d0
     & /4/ctw**2*vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn*ts/
     & us-1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2)
     & +propiwqs*c0tacustazc*mta**2*(-1d0/4/ctw**2*vpaup*vmata/qs)
     & +propiwqs*c0tacustazc*mta**4*(-1d0/4/ctw**2*vpaup*vmata/qs/us)
     & +propiwqs*c0ccqswcz*mta**2*(-1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2
     & +1d0/4/ctw**2*vpaup*vpatn*ts/us**2-1d0/4/ctw**2*vpaup*vmata/us+1d
     & 0/2/ctw**2*vpadn*vpata*ts/us**2-1d0/4/ctw**2*vpadn*vpata/us**2*mw
     & **2+1d0/4/ctw**2*vpadn*vpata/us-1d0/4/ctw**2*vpadn*vmata/us)
     & +propiwqs*c0ccqswcz*mta**4*(1d0/4/ctw**2*vpadn*vpata/us**2)
     & +propiwqs*c0ccqswcz*(-1d0/4/ctw**4*vpaup*vpatn*ts/us**2*mw**2-1d0
     & /4/ctw**4*vpaup*vpatn/us*mw**2-1d0/4/ctw**4*vpadn*vpata*ts/us**2*
     & mw**2-1d0/4/ctw**4*vpadn*vpata/us*mw**2-1d0/4/ctw**2*vpaup*vpatn*
     & ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2-1d0/4/ctw**2*
     & vpaup*vpatn/us*mw**2+1d0/4/ctw**2*vpaup*vpatn-1d0/2/ctw**2*vpaup*
     & vpata-1d0/2/ctw**2*vpadn*vpatn-1d0/4/ctw**2*vpadn*vpata*ts/us**2*
     & mw**2+1d0/4/ctw**2*vpadn*vpata*ts**2/us**2-1d0/4/ctw**2*vpadn*vpa
     & ta/us*mw**2+1d0/4/ctw**2*vpadn*vpata)
     & +propiwqs*c0cctscwta*mta**2*(-1d0/4/ctw**4*vpadn*vpata/qs/us*mw**
     & 2-1d0/4/ctw**4*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/q
     & s-1d0/4/ctw**2*vpadn*vpata*ts/us**2-1d0/4/ctw**2*vpadn*vpata/us+1
     & d0/4/ctw**2*vpadn*vmata/qs+1d0/4/ctw**2*vpadn*vmata/us+ctw**2*qdn
     & *qta*ts/us**2-qdn*qta*ts/us**2)
     & +propiwqs*c0cctscwta*mta**4*(-1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpata/qs/us+1d0/4/ctw**2*vpadn*vmata/qs/u
     & s)
     & +propiwqs*c0cctscwta*(1d0/4/ctw**4*vpadn*vpata*ts/us**2*mw**2+1d0
     & /4/ctw**2*vpadn*vpata*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpata*ts/
     & us-1d0/4/ctw**2*vpadn*vpata*ts**2/us**2-ctw**2*qdn*qta*ts/us**2*m
     & w**2-ctw**2*qdn*qta*ts/us+ctw**2*qdn*qta*ts**2/us**2+qdn*qta*ts/u
     & s**2*mw**2+qdn*qta*ts/us-qdn*qta*ts**2/us**2)
     & +propiwqs*c0cctsczc*mta**2*(-1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2
     & -1d0/4/ctw**2*vpaup*vpatn/qs-1d0/4/ctw**2*vpaup*vpatn/us**2*mw**2
     & -1d0/4/ctw**2*vpaup*vpatn/us)
     & +propiwqs*c0cctsczc*mta**4*(-1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpatn/qs/us)
     & +propiwqs*c0cctsczc*(1d0/4/ctw**4*vpaup*vpatn*ts/us**2*mw**2+1d0/
     & 4/ctw**2*vpaup*vpatn*ts/us**2*mw**2+1d0/4/ctw**2*vpaup*vpatn*ts/u
     & s-1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2)
     & +propiwqs*c0ccuscwta*mta**2*(1d0/4/ctw**2*vpaup*vmata/qs-ctw**2*q
     & up*qta/qs+qup*qta/qs)
     & +propiwqs*a0fw*(3/qs*mw**2/mh**2-4/qs)
     & +propiwqs*a0fz*mta**2*(1d0/ctw**2*vpadn*vpatn/ts/us)
     & +propiwqs*a0fz*(3d0/2/ctw**4/qs*mw**2/mh**2)
     & +propiwqs*a0fta*mta**2*(2*stw**2*qup*qta/ts/us)
     & +propiwqs*b0ftawc*mta**2*(-1d0/2/ctw**2*vpadn*vpatn/ts/us)
     & +propiwqs*b0ftawc*(-1d0/2/ctw**2*vpaup*vpatn/qs)
     & +propiwqs*b0ftazta*mta**2*(-1d0/2/ctw**2*vpaup*vpata/ts/us)
     & +propiwqs*b0ftazta*(-1d0/2/ctw**2*vpadn*vpata/qs)
     & +propiwqs*b0fqswz*mta**2*(3d0/2/ctw**2*vpaup*vpata/ts/us+3d0/2/ct
     & w**2*vpadn*vpatn/ts/us)
     & +propiwqs*b0fqswz*(1d0/2/ctw**2*vpaup*vpatn/qs-1d0/2/ctw**2*vpaup
     & *vpatn/us+1d0/2/ctw**2*vpadn*vpata/qs-1d0/2/ctw**2*vpadn*vpata/us
     & +5d0/6/ctw**2/qs-14d0/3*ctw**2/qs-53d0/12/qs)
     & +propiwqs*b0fqswh*(11d0/12/qs)
     & +propiwqs*b0fqswc*mta**2*(-6*ctw**2*qup*qta/ts/us+6*qup*qta/ts/us
     & )
     & +propiwqs*b0fqswc*(-2*ctw**2*qdn*qta/qs+2*ctw**2*qdn*qta/us+14d0/
     & 3*ctw**2/qs+2*qdn*qta/qs-2*qdn*qta/us-14d0/3/qs)
     & +propiwqs*b0ftstac*(1d0/2/ctw**2*vpadn*vpata/us-2*ctw**2*qdn*qta/
     & us+2*qdn*qta/us)
     & +propiwqs*b0ftscc*(1d0/2/ctw**2*vpaup*vpatn/us)
     & +propiwqs*b0fcwta*mta**2*(-1d0/ctw**2*vpaup*vpata/ts/us+4*ctw**2*
     & qup*qta/ts/us-4*qup*qta/ts/us)
     & +propiwqs*(1d0/ctw**4/qs*mw**2/mh**2-1d0/6/ctw**2/qs+2*ctw**2*qdn
     & *qta/qs-2*qdn*qta/qs+2/qs*mw**2/mh**2-64d0/9/qs)
     & +sdet3ictaqs**2*mta**2*(2*ctw**2*qta*mw**2-2*qta*mw**2)
     & +sdet3ictaqs**2*mta**4*(-2*ctw**2*qta+2*qta)
     & +sdet3ictaqs**2*c0tacqswcz*mta**2*(-1d0/ctw**4*vpatn*mw**4)
     & +sdet3ictaqs**2*c0tacqsztaw*mta**2*(vpata*mw**4)
     & +sdet3ictaqs**2*c0tacqsztaw*mta**4*(-7d0/4*vpata*mw**2-1d0/4*vmat
     & a*mw**2)
     & +sdet3ictaqs**2*c0tacqsztaw*mta**6*(1d0/2*vpata+1d0/2*vmata)
     & +sdet3ictaqs**2*c0tacqsztaw*mta**8*(1d0/4*vpata/mw**2-1d0/4*vmata
     & /mw**2)
     & +sdet3ictaqs**2*c0tacqshtaw*mta**4*(-1d0/4*mw**2)
     & +sdet3ictaqs**2*c0tacqshtaw*mta**6*(1d0/2)
     & +sdet3ictaqs**2*c0tacqshtaw*mta**8*(-1d0/4/mw**2)
     & +sdet3ictaqs**2*c0tacqstazc*mta**2*(1d0/2/ctw**6*vpatn*vpata*mw**
     & 4)
     & +sdet3ictaqs**2*c0tacqsctaw*mta**2*(-2*stw**2*mw**4)
     & +sdet3ictaqs**2*c0tacqsctaw*mta**4*(8*stw**2*qdn/ts*mw**4+8*stw**
     & 2*qdn/us*mw**4+8*stw**2/ts*mw**4+8*stw**2/us*mw**4+4*stw**2*mw**2
     & )
     & +sdet3ictaqs**2*c0tacqsctaw*mta**6*(-16*stw**2*qdn/ts*mw**2-16*st
     & w**2*qdn/us*mw**2-16*stw**2/ts*mw**2-16*stw**2/us*mw**2-2*stw**2)
     & 
     & +sdet3ictaqs**2*c0tacqsctaw*mta**8*(8*stw**2*qdn/ts+8*stw**2*qdn/
     & us+8*stw**2/ts+8*stw**2/us)
     & +sdet3ictaqs**2*a0fta*mta**2*(2*stw**2*qta*mw**2)
     & +sdet3ictaqs**2*a0fta*mta**4*(-2*stw**2*qta)
     & +sdet3ictaqs**2*b0ftawc*mta**2*(1d0/ctw**2*vpatn*mw**2)
     & +sdet3ictaqs**2*b0ftazta*mta**2*(1d0/2/ctw**4*vpatn*vpata*mw**2-v
     & pata*mw**2)
     & +sdet3ictaqs**2*b0ftazta*mta**4*(3d0/4*vpata+1d0/4*vmata)
     & +sdet3ictaqs**2*b0ftazta*mta**6*(1d0/4*vpata/mw**2-1d0/4*vmata/mw
     & **2)
     & +sdet3ictaqs**2*b0ftahta*mta**4*(1d0/4)
     & +sdet3ictaqs**2*b0ftahta*mta**6*(-1d0/4/mw**2)
     & +sdet3ictaqs**2*b0fqswz*mta**2*(-1d0/ctw**2*vpatn*mw**2+vpata*mw*
     & *2)
     & +sdet3ictaqs**2*b0fqswz*mta**4*(-3d0/4*vpata-1d0/4*vmata)
     & +sdet3ictaqs**2*b0fqswz*mta**6*(-1d0/4*vpata/mw**2+1d0/4*vmata/mw
     & **2)
     & +sdet3ictaqs**2*b0fqswh*mta**4*(-1d0/4)
     & +sdet3ictaqs**2*b0fqswh*mta**6*(1d0/4/mw**2)
     & +sdet3ictaqs**2*b0fqswc*mta**2*(-2*ctw**2*qta*mw**2+2*qta*mw**2)
     & +sdet3ictaqs**2*b0fqswc*mta**4*(2*ctw**2*qta-2*qta)
     & +sdet3ictaqs**2*b0fqstac*mta**2*(-1d0/2/ctw**4*vpatn*vpata*mw**2)
     & +sdet3ictaqs*c0tacqswcz*mta**2*(1d0/2/ctw**4*vpatn*mw**2)
     & +sdet3ictaqs*c0tacqswcz*(1d0/ctw**2*vpatn*mw**4)
     & +sdet3ictaqs*c0tacqsztaw*mta**2*(3d0/4/ctw**2*vpata*mw**2-1d0/4/c
     & tw**2*vmata*mw**2+1d0/2*vpata*mw**2+1d0/2*vmata*mw**2)
     & +sdet3ictaqs*c0tacqsztaw*mta**4*(1d0/4/ctw**2*vpata+1d0/4/ctw**2*
     & vmata-vmata)
     & +sdet3ictaqs*c0tacqsztaw*mta**6*(-1d0/2*vpata/mw**2+1d0/2*vmata/m
     & w**2)
     & +sdet3ictaqs*c0tacqsztaw*(-1d0/ctw**2*vpata*mw**4)
     & +sdet3ictaqs*c0tacqshtaw*mta**2*(-1d0/2*mw**2+1d0/4*mh**2)
     & +sdet3ictaqs*c0tacqshtaw*mta**4*(-1d0/4/mw**2*mh**2)
     & +sdet3ictaqs*c0tacqshtaw*mta**6*(1d0/2/mw**2)
     & +sdet3ictaqs*c0tacqstazc*mta**2*(-1d0/2/ctw**4*vpatn*vpata*mw**2)
     & +sdet3ictaqs*c0tacqstazc*(-1d0/2/ctw**6*vpatn*vpata*mw**4)
     & +sdet3ictaqs*c0tacqsctaw*mta**2*(2*stw**2*qdn/qs*mw**4-2*stw**2*q
     & dn/ts*mw**4-2*stw**2*qdn/us*mw**4-2*stw**2/ts*mw**4-2*stw**2/us*m
     & w**4-2*stw**2*mw**2)
     & +sdet3ictaqs*c0tacqsctaw*mta**4*(8*stw**2*qdn/ts/us*mw**4+20*stw*
     & *2*qdn/ts*mw**2+20*stw**2*qdn/us*mw**2+8*stw**2/ts/us*mw**4+20*st
     & w**2/ts*mw**2+20*stw**2/us*mw**2+2*stw**2)
     & +sdet3ictaqs*c0tacqsctaw*mta**6*(-16*stw**2*qdn/ts/us*mw**2-18*st
     & w**2*qdn/ts-18*stw**2*qdn/us-16*stw**2/ts/us*mw**2-18*stw**2/ts-1
     & 8*stw**2/us)
     & +sdet3ictaqs*c0tacqsctaw*mta**8*(8*stw**2*qdn/ts/us+8*stw**2/ts/u
     & s)
     & +sdet3ictaqs*c0tacqsctaw*(2*stw**2*qdn*mw**4)
     & +sdet3ictaqs*a0fw*mta**2*(1d0/8-1d0/8*vpata+1d0/8*vmata)
     & +sdet3ictaqs*a0fw*(ctw**2*qta*mw**2-qta*mw**2-1d0/2*vpata*mw**2)
     & +sdet3ictaqs*a0fz*(1d0/4/ctw**4*vpatn*vpata*mw**2+1d0/2/ctw**2*vp
     & atn*mw**2)
     & +sdet3ictaqs*a0fta*mta**2*(stw**2*qta+1d0/2*vpata)
     & +sdet3ictaqs*a0fta*mta**4*(1d0/8*vpata/mw**2-1d0/8*vmata/mw**2-1d
     & 0/8/mw**2)
     & +sdet3ictaqs*b0ftawc*mta**2*(-1d0/2/ctw**2*vpatn-1d0/2*vpatn)
     & +sdet3ictaqs*b0ftawc*(-1d0/2*vpatn*mw**2)
     & +sdet3ictaqs*b0ftazta*mta**2*(-1d0/2/ctw**2*vpatn*vpata+1d0/8/ctw
     & **2*vpata+3d0/8/ctw**2*vmata+1d0/2*vpata-1d0/2*vmata)
     & +sdet3ictaqs*b0ftazta*mta**4*(-1d0/4*vpata/mw**2+1d0/4*vmata/mw**
     & 2)
     & +sdet3ictaqs*b0ftazta*(-1d0/4/ctw**4*vpatn*vpata*mw**2+1d0/2/ctw*
     & *2*vpata*mw**2)
     & +sdet3ictaqs*b0ftahta*mta**2*(1d0/2-1d0/8/mw**2*mh**2)
     & +sdet3ictaqs*b0ftahta*mta**4*(1d0/4/mw**2)
     & +sdet3ictaqs*b0fqswz*mta**2*(1d0/2/ctw**2*vpatn-1d0/8/ctw**2*vpat
     & a-3d0/8/ctw**2*vmata+1d0/2*vpatn-1d0/8*vpata+5d0/8*vmata)
     & +sdet3ictaqs*b0fqswz*mta**4*(3d0/8*vpata/mw**2-3d0/8*vmata/mw**2)
     & +sdet3ictaqs*b0fqswz*(1d0/2/ctw**2*vpatn*mw**2-1d0/2/ctw**2*vpata
     & *mw**2+1d0/2*vpatn*mw**2-1d0/2*vpata*mw**2)
     & +sdet3ictaqs*b0fqswh*mta**2*(-3d0/8+1d0/8/mw**2*mh**2)
     & +sdet3ictaqs*b0fqswh*mta**4*(-3d0/8/mw**2)
     & +sdet3ictaqs*b0fqswc*mta**2*(-ctw**2*qta+qta)
     & +sdet3ictaqs*b0fqswc*(ctw**2*qta*mw**2-qta*mw**2)
     & +sdet3ictaqs*b0fqstac*mta**2*(1d0/2/ctw**2*vpatn*vpata)
     & +sdet3ictaqs*b0fqstac*(1d0/2/ctw**4*vpatn*vpata*mw**2)
     & +sdet3ictaus*c0tacqsctaw*mta**2*(stw**2*qdn*ts-stw**2*qdn*mw**2+s
     & tw**2*ts-stw**2*mw**2)
     & +sdet3ictaus*c0tacqsctaw*mta**4*(-stw**2*qdn/qs*mw**2+stw**2*qdn*
     & ts/us-stw**2*qdn/us*mw**2-stw**2/qs*mw**2+stw**2*ts/us-stw**2/us*
     & mw**2)
     & +sdet3ictaus*c0tacqsctaw*mta**6*(-stw**2*qdn/qs/us*mw**2-stw**2/q
     & s/us*mw**2)
     & +javsubqstsctaw*mta**2*(4*ctw**2*qdn*qta*ts/us**2*mw**2-3*ctw**2*
     & qdn*qta*ts**2/us**2-ctw**2*qdn*qta/us**2*mw**4-ctw**2*qdn*qta-4*q
     & dn*qta*ts/us**2*mw**2+3*qdn*qta*ts**2/us**2+qdn*qta/us**2*mw**4+q
     & dn*qta)
     & +javsubqstsctaw*mta**4*(-3*ctw**2*qdn*qta*ts/us**2+2*ctw**2*qdn*q
     & ta/us**2*mw**2+3*qdn*qta*ts/us**2-2*qdn*qta/us**2*mw**2)
     & +javsubqstsctaw*mta**6*(-ctw**2*qdn*qta/us**2+qdn*qta/us**2)
     & +javsubqstsctaw*(-ctw**2*qdn*qta*ts/us**2*mw**4-ctw**2*qdn*qta*ts
     & +2*ctw**2*qdn*qta*ts**2/us**2*mw**2-ctw**2*qdn*qta*ts**3/us**2+qd
     & n*qta*ts/us**2*mw**4+qdn*qta*ts-2*qdn*qta*ts**2/us**2*mw**2+qdn*q
     & ta*ts**3/us**2)
     & +javsubqsusctaw*mta**2*(ctw**2*qup*qta/qs*mw**2+3*ctw**2*qup*qta-
     & qup*qta/qs*mw**2-3*qup*qta)
     & +javsubqsusctaw*mta**4*(ctw**2*qup*qta/qs/us*mw**2+ctw**2*qup*qta
     & /us-qup*qta/qs/us*mw**2-qup*qta/us)
     & +javsubqsusctaw*(2*ctw**2*qup*qta*us-2*qup*qta*us)
     & +c0tacqswcz*mta**2*(vpatn)
     & +c0tacqswcz*(-1d0/ctw**2*vpatn*mw**2-vpatn*mw**2)
     & +c0tacqsztaw*mta**2*(-1d0/2/ctw**2*vpata-1d0/2*vpata+3d0/2*vmata)
     & +c0tacqsztaw*mta**4*(1d0/4*vpata/mw**2-1d0/4*vmata/mw**2)
     & +c0tacqsztaw*(1d0/ctw**2*vpata*mw**2+vpata*mw**2)
     & +c0tacqshtaw*mta**2*(1d0/2)
     & +c0tacqshtaw*mta**4*(-1d0/4/mw**2)
     & +c0tacqstazc*(1d0/ctw**4*vpatn*vpata*mw**2+1d0/2/ctw**2*vpatn*vpa
     & ta*ts+1d0/2/ctw**2*vpatn*vpata*us)
     & +c0tacqsctaw*mta**2*(-2*stw**2*qdn/ts/us*mw**4+stw**2*qdn*ts/us-s
     & tw**2*qdn/us*mw**2+2*stw**2*qdn-2*stw**2/ts/us*mw**4+stw**2*ts/us
     & -stw**2/us*mw**2-2*stw**2)
     & +c0tacqsctaw*mta**4*(-stw**2*qdn/qs/us*mw**2+20*stw**2*qdn/ts/us*
     & mw**2-stw**2/qs/us*mw**2+20*stw**2/ts/us*mw**2)
     & +c0tacqsctaw*mta**6*(-18*stw**2*qdn/ts/us-18*stw**2/ts/us)
     & +c0tacqsctaw*(-2*stw**2*qdn/qs*mw**4)
     & +c0ccqswcz*(1d0/ctw**2*vpaup/qs*mw**4-1d0/ctw**2*vpaup*mw**2-1d0/
     & ctw**2*vpadn/qs*mw**4+1d0/ctw**2*vpadn*mw**2-vpaup*mw**2+vpadn*mw
     & **2)
     & +c0ccqsczc*mta**2*(1d0/2/ctw**2*vpaup*vpadn)
     & +c0ccqsczc*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**4+1d0/ctw**4*vpaup*v
     & padn*mw**2+1d0/2/ctw**2*vpaup*vpadn*ts+1d0/2/ctw**2*vpaup*vpadn*u
     & s)
     & +c0cctscwta*mta**2*(4*ctw**2*qdn*qta*ts/us**2*mw**2-3*ctw**2*qdn*
     & qta*ts**2/us**2-ctw**2*qdn*qta/us**2*mw**4-ctw**2*qdn*qta-4*qdn*q
     & ta*ts/us**2*mw**2+3*qdn*qta*ts**2/us**2+qdn*qta/us**2*mw**4+qdn*q
     & ta)
     & +c0cctscwta*mta**4*(-3*ctw**2*qdn*qta*ts/us**2+2*ctw**2*qdn*qta/u
     & s**2*mw**2+3*qdn*qta*ts/us**2-2*qdn*qta/us**2*mw**2)
     & +c0cctscwta*mta**6*(-ctw**2*qdn*qta/us**2+qdn*qta/us**2)
     & +c0cctscwta*(-ctw**2*qdn*qta*ts/us**2*mw**4-ctw**2*qdn*qta*ts+2*c
     & tw**2*qdn*qta*ts**2/us**2*mw**2-ctw**2*qdn*qta*ts**3/us**2+qdn*qt
     & a*ts/us**2*mw**4+qdn*qta*ts-2*qdn*qta*ts**2/us**2*mw**2+qdn*qta*t
     & s**3/us**2)
     & +c0ccuscwta*mta**2*(ctw**2*qup*qta/qs*mw**2+3*ctw**2*qup*qta-qup*
     & qta/qs*mw**2-3*qup*qta)
     & +c0ccuscwta*mta**4*(ctw**2*qup*qta/qs/us*mw**2+ctw**2*qup*qta/us-
     & qup*qta/qs/us*mw**2-qup*qta/us)
     & +c0ccuscwta*(2*ctw**2*qup*qta*us-2*qup*qta*us)
     & +a0fw*(65d0/8+1d0/12/ctw**2/qs*mw**2-ctw**2*qup/qs*mw**2+2*ctw**2
     & *qup+ctw**2*qdn/qs*mw**2-2*ctw**2*qdn+qup/qs*mw**2-2*qup-qdn/qs*m
     & w**2+2*qdn+1d0/2*vpaup/qs*mw**2-vpaup-1d0/2*vpadn/qs*mw**2+vpadn+
     & 23d0/6/qs*mw**2-3/qs*mw**4/mh**2+1d0/12/qs*mh**2-3*mw**2/mh**2+7d
     & 0/8*invftaw-2*invftaw*ctw**2*qta+2*invftaw*qta+invftaw*vpata-3d0/
     & 8*invftaw**2)
     & +a0fz*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-1d0/12/ctw**4/qs*mw**2-3
     & d0/2/ctw**4/qs*mw**4/mh**2-3d0/2/ctw**4*mw**2/mh**2-1d0/ctw**2*vp
     & aup*vpadn+1d0/2/ctw**2*vpaup/qs*mw**2+1d0/8/ctw**2*vpaup**2-1d0/2
     & /ctw**2*vpadn/qs*mw**2+1d0/8/ctw**2*vpadn**2-1d0/2/ctw**2*vpatn*v
     & pata+1d0/8/ctw**2*vpatn**2+1d0/8/ctw**2*vpata*vmata-1d0/16/ctw**2
     & *vpata**2+1d0/16/ctw**2*vmata**2-7d0/12/ctw**2/qs*mw**2-vpaup+vpa
     & dn-vpatn+2d0/3/qs*mw**2)
     & +a0fh*(1d0/12/qs*mh**2-1d0/16/mw**2*mh**2)
     & +a0fta*mta**2*(1d0/4*stw**4*qta**2/mw**2-1d0/8*vpata*vmata/mw**2+
     & 1d0/16*vpata**2/mw**2+3d0/16/mw**2-2*invftaw*stw**2*qta/mw**2-inv
     & ftaw*vpata/mw**2-7d0/8*invftaw/mw**2+3d0/8*invftaw**2/mw**2)
     & +a0fta*(-3d0/8+3d0/8*invftaw)
     & +b0ftawc*(-3d0/8+vpatn)
     & +b0ftazta*(1d0/2/ctw**2*vpatn*vpata+1d0/8/ctw**2*vpata*vmata-3d0/
     & 16/ctw**2*vpata**2+1d0/16/ctw**2*vmata**2-vpata)
     & +b0ftahta*(-1d0/16/mw**2*mh**2)
     & +b0fqswz*mta**2*(-1d0/8*vpata/mw**2+1d0/8*vmata/mw**2)
     & +b0fqswz*(13d0/3-1d0/12/ctw**4/qs*mw**2+1d0/2/ctw**2*vpaup/qs*mw*
     & *2-1d0/2/ctw**2*vpadn/qs*mw**2-4d0/3/ctw**2/qs*mw**2-5d0/6/ctw**2
     & +4*ctw**2/qs*mw**2+8*ctw**2+1d0/2*vpaup/qs*mw**2-1d0/2*vpaup-1d0/
     & 2*vpadn/qs*mw**2+1d0/2*vpadn-1d0/2*vpatn+1d0/2*vpata+17d0/3/qs*mw
     & **2)
     & +b0fqswh*mta**2*(1d0/8/mw**2)
     & +b0fqswh*(-1-1d0/qs*mw**2+1d0/6/qs*mh**2)
     & +b0fqswc*(8-ctw**2*qup/qs*mw**2+ctw**2*qup+ctw**2*qdn/qs*mw**2-ct
     & w**2*qdn-ctw**2*qta-4*ctw**2/qs*mw**2-8*ctw**2+qup/qs*mw**2-qup-q
     & dn/qs*mw**2+qdn+qta+4/qs*mw**2)
     & +b0fqstac*(-3d0/4/ctw**2*vpatn*vpata)
     & +b0fqscc*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-3d0/4/ctw**2*vpaup*vp
     & adn+3*ctw**2*qup*qdn-3*qup*qdn)
     & +dreal(b0ptazta)*mta**2*(-3d0/4/ctw**2*vpata*vmata+1d0/8/ctw**2*v
     & pata**2+1d0/8/ctw**2*vmata**2)
     & +dreal(b0ptazta)*(-1d0/8/ctw**4*vpata**2*mw**2-1d0/8/ctw**4*vmata
     & **2*mw**2)
     & +dreal(b0ptahta)*mta**2*(-1d0/8/mw**2*mh**2)
     & +dreal(b0ptahta)*mta**4*(1d0/2/mw**2)
     & +dreal(b0ptacw)*mta**2*(1d0/8)
     & +dreal(b0ptacw)*mta**4*(1d0/8/mw**2)
     & +dreal(b0ptacw)*(-1d0/4*mw**2)
     & +110d0/9+1d0/stw**2*ctw**2*deltarhobos+1d0/stw**2*ctw**2*deltarho
     & fer-1d0/ctw**4/qs*mw**4/mh**2-1d0/ctw**4*mw**2/mh**2-1d0/2/ctw**2
     & *vpaup*vpadn+3d0/16/ctw**2*vpaup**2+3d0/16/ctw**2*vpadn**2-1d0/2/
     & ctw**2*vpatn*vpata+3d0/16/ctw**2*vpatn**2+1d0/8/ctw**2*vpata**2-1
     & d0/16/ctw**2*vmata**2+1d0/6/ctw**2/qs*mw**2+1d0/6/ctw**2-2*ctw**2
     & *qup*qdn-2*ctw**2*qup+3d0/2*ctw**2*qup**2+2*ctw**2*qdn+3d0/2*ctw*
     & *2*qdn**2+2*ctw**2*qta+3d0/2*ctw**2*qta**2+2*qup*qdn+2*qup-3d0/2*
     & qup**2-2*qdn-3d0/2*qdn**2-2*qta-3d0/2*qta**2+64d0/9/qs*mw**2-2/qs
     & *mw**4/mh**2-2*mw**2/mh**2-za1bos-za1fer+caldwfer+3d0/8*invftaw

      ff_ew_ld =
     & 0

      ff_ew_rd =
     & +propiwqs*mta*(ctw**2*qdn*qta/ts/us-qdn*qta/ts/us)
     & +propiwqs*sdet3ictaqs*mta*(ctw**2*qdn*qta/ts-ctw**2*qdn*qta/us-qd
     & n*qta/ts+qdn*qta/us)
     & +propiwqs*sdet3ictaqs*c0tacqswcz*mta*(1d0/4/ctw**4*vpaup*vpatn/ts
     & *mw**2-1d0/4/ctw**4*vpaup*vpatn/us*mw**2)
     & +propiwqs*sdet3ictaqs*c0tacqsztaw*mta*(1d0/4/ctw**2*vpadn*vpata/t
     & s*mw**2-1d0/4/ctw**2*vpadn*vpata/us*mw**2)
     & +propiwqs*sdet3ictaqs*c0tacqsztaw*mta**3*(-1d0/4/ctw**2*vpadn*vpa
     & ta/ts+1d0/4/ctw**2*vpadn*vpata/us)
     & +propiwqs*sdet3ictaqs*a0fta*mta*(stw**2*qdn*qta/ts-stw**2*qdn*qta
     & /us)
     & +propiwqs*sdet3ictaqs*b0ftawc*mta*(-1d0/4/ctw**2*vpaup*vpatn/ts+1
     & d0/4/ctw**2*vpaup*vpatn/us)
     & +propiwqs*sdet3ictaqs*b0ftazta*mta*(-1d0/4/ctw**2*vpadn*vpata/ts+
     & 1d0/4/ctw**2*vpadn*vpata/us)
     & +propiwqs*sdet3ictaqs*b0fqswz*mta*(1d0/4/ctw**2*vpaup*vpatn/ts-1d
     & 0/4/ctw**2*vpaup*vpatn/us+1d0/4/ctw**2*vpadn*vpata/ts-1d0/4/ctw**
     & 2*vpadn*vpata/us)
     & +propiwqs*sdet3ictaqs*b0fqswc*mta*(-ctw**2*qdn*qta/ts+ctw**2*qdn*
     & qta/us+qdn*qta/ts-qdn*qta/us)
     & +propiwqs*sdet3ictats*mta*(-2*ctw**2*qdn*qta/us+2*qdn*qta/us)
     & +propiwqs*sdet3ictats*c0tactstazc*mta*(1d0/2/ctw**4*vpadn*vpata/u
     & s*mw**2)
     & +propiwqs*sdet3ictats*c0tactscwc*mta*(1d0/2/ctw**2*vpaup*vpatn/us
     & *mw**2)
     & +propiwqs*sdet3ictats*a0fta*mta*(-2*stw**2*qdn*qta/us)
     & +propiwqs*sdet3ictats*b0ftawc*mta*(1d0/2/ctw**2*vpaup*vpatn/us)
     & +propiwqs*sdet3ictats*b0ftazta*mta*(1d0/2/ctw**2*vpadn*vpata/us)
     & +propiwqs*sdet3ictats*b0ftstac*mta*(-1d0/2/ctw**2*vpadn*vpata/us+
     & 2*ctw**2*qdn*qta/us-2*qdn*qta/us)
     & +propiwqs*sdet3ictats*b0ftscc*mta*(-1d0/2/ctw**2*vpaup*vpatn/us)
     & +propiwqs*d0cctacqsuswczta*mta*(-1d0/4/ctw**4*vpaup*vmata/qs*mw**
     & 2+1d0/4/ctw**4*vpaup*vmata/ts*mw**2+1d0/4/ctw**2*vpaup*vmata/qs*m
     & w**2-1d0/4/ctw**2*vpaup*vmata/ts*us+1d0/4/ctw**2*vpaup*vmata/ts*m
     & w**2)
     & +propiwqs*d0cctacqsuswczta*mta**3*(1d0/4/ctw**2*vpaup*vmata/qs/us
     & *mw**2+1d0/4/ctw**2*vpaup*vmata/ts/us*mw**2-1d0/2/ctw**2*vpaup*vm
     & ata/ts)
     & +propiwqs*d0cctacqsuswczta*mta**5*(-1d0/4/ctw**2*vpaup*vmata/ts/u
     & s)
     & +propiwqs*d0ccctaqstswczc*mta*(1d0/4/ctw**6*vpaup*vpatn/us**2*mw*
     & *4-1d0/4/ctw**4*vpaup*vpatn/qs/us*mw**4-1d0/4/ctw**4*vpaup*vpatn/
     & qs*mw**2-1d0/2/ctw**4*vpaup*vpatn*ts/us**2*mw**2+1d0/2/ctw**4*vpa
     & up*vpatn/us**2*mw**4+1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**4+1d0/4/c
     & tw**2*vpaup*vpatn/qs*mw**2-1d0/2/ctw**2*vpaup*vpatn*ts/us**2*mw**
     & 2+1d0/4/ctw**2*vpaup*vpatn*ts**2/us**2+1d0/4/ctw**2*vpaup*vpatn/u
     & s**2*mw**4+1d0/4/ctw**2*vpaup*vpatn/us*mw**2)
     & +propiwqs*d0ccctaqstswczc*mta**3*(1d0/4/ctw**6*vpaup*vpatn/ts/us*
     & *2*mw**4-1d0/2/ctw**4*vpaup*vpatn/us**2*mw**2+1d0/4/ctw**2*vpaup*
     & vpatn/qs/us**2*mw**4+1d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2+1d0/4/c
     & tw**2*vpaup*vpatn*ts/us**2)
     & +propiwqs*d0ccctaqstszcwta*mta*(1d0/4/ctw**6*vpadn*vpata/qs/us*mw
     & **4+1d0/4/ctw**6*vpadn*vpata/us**2*mw**4-1d0/4/ctw**4*vpadn*vpata
     & /qs/us*mw**4+1d0/4/ctw**4*vpadn*vpata/qs*mw**2-1d0/2/ctw**4*vpadn
     & *vpata*ts/us**2*mw**2+1d0/2/ctw**4*vpadn*vpata/us**2*mw**4+1d0/4/
     & ctw**4*vpadn*vpata/us*mw**2-1d0/4/ctw**4*vpadn*vmata/qs*mw**2-1d0
     & /4/ctw**4*vpadn*vmata/us*mw**2-1d0/4/ctw**2*vpadn*vpata/qs*mw**2-
     & 1d0/2/ctw**2*vpadn*vpata*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpata*
     & ts**2/us**2+1d0/4/ctw**2*vpadn*vpata/us**2*mw**4+1d0/4/ctw**2*vpa
     & dn*vmata/qs*mw**2+1d0/4/ctw**2*vpadn*vmata*ts/us-1d0/4/ctw**2*vpa
     & dn*vmata/us*mw**2)
     & +propiwqs*d0ccctaqstszcwta*mta**3*(1d0/4/ctw**6*vpadn*vpata/qs/us
     & **2*mw**4+1d0/4/ctw**4*vpadn*vpata/qs/us*mw**2-1d0/2/ctw**4*vpadn
     & *vpata/us**2*mw**2-1d0/4/ctw**4*vpadn*vmata/qs/us*mw**2+1d0/4/ctw
     & **2*vpadn*vpata/ts/us**2*mw**4-1d0/4/ctw**2*vpadn*vpata/ts/us*mw*
     & *2+3d0/4/ctw**2*vpadn*vpata*ts/us**2-1d0/ctw**2*vpadn*vpata/us**2
     & *mw**2+1d0/4/ctw**2*vpadn*vpata/us+1d0/4/ctw**2*vpadn*vmata/us)
     & +propiwqs*d0ccctaqstszcwta*mta**5*(-1d0/2/ctw**2*vpadn*vpata/ts/u
     & s**2*mw**2+1d0/4/ctw**2*vpadn*vpata/ts/us+3d0/4/ctw**2*vpadn*vpat
     & a/us**2)
     & +propiwqs*d0ccctaqstszcwta*mta**7*(1d0/4/ctw**2*vpadn*vpata/ts/us
     & **2)
     & +propiwqs*c0tacqswcz*mta*(1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2-1d
     & 0/4/ctw**2*vpaup*vpatn*ts/us**2+1d0/4/ctw**2*vpaup*vpatn/us**2*mw
     & **2)
     & +propiwqs*c0tacqswcz*mta**3*(1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2+1d0/4/ctw**2*vpaup*vpatn/qs/us)
     & +propiwqs*c0tacqsztaw*mta*(1d0/4/ctw**4*vpadn*vpata/us**2*mw**2+1
     & d0/4/ctw**2*vpaup*vmata/ts-1d0/4/ctw**2*vpadn*vpata*ts/us**2+1d0/
     & 4/ctw**2*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vmata/us)
     & +propiwqs*c0tacqsztaw*mta**3*(1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2+1d0/4/ctw**2*vpaup*vmata/qs/us+1d0/4/ctw**2*vpadn*vpata/qs/u
     & s-1d0/4/ctw**2*vpadn*vpata/us**2-1d0/4/ctw**2*vpadn*vmata/qs/us)
     & +propiwqs*c0tactstazc*mta*(1d0/4/ctw**4*vpadn*vpata/qs/us*mw**2-1
     & d0/4/ctw**4*vpadn*vpata/us**2*mw**2+1d0/4/ctw**2*vpadn*vpata/qs+1
     & d0/4/ctw**2*vpadn*vpata*ts/us**2-1d0/4/ctw**2*vpadn*vpata/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpata/us-1d0/4/ctw**2*vpadn*vmata/qs+1d0/
     & 4/ctw**2*vpadn*vmata/us)
     & +propiwqs*c0tactstazc*mta**3*(-1d0/4/ctw**2*vpadn*vpata/ts/us**2*
     & mw**2+1d0/2/ctw**2*vpadn*vpata/us**2)
     & +propiwqs*c0tactstazc*mta**5*(1d0/4/ctw**2*vpadn*vpata/ts/us**2)
     & +propiwqs*c0tactscwc*mta*(-1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2+1
     & d0/4/ctw**2*vpaup*vpatn/qs/us*mw**2+1d0/4/ctw**2*vpaup*vpatn/qs+1
     & d0/4/ctw**2*vpaup*vpatn*ts/us**2-1d0/4/ctw**2*vpaup*vpatn/us**2*m
     & w**2-1d0/4/ctw**2*vpaup*vpatn/us)
     & +propiwqs*c0tactscwc*mta**3*(-1d0/4/ctw**4*vpaup*vpatn/ts/us**2*m
     & w**2+1d0/4/ctw**2*vpaup*vpatn/us**2)
     & +propiwqs*c0tacustazc*mta*(-1d0/4/ctw**2*vpaup*vmata/qs-1d0/4/ctw
     & **2*vpaup*vmata/ts)
     & +propiwqs*c0tacustazc*mta**3*(-1d0/4/ctw**2*vpaup*vmata/qs/us-1d0
     & /4/ctw**2*vpaup*vmata/ts/us)
     & +propiwqs*c0ccqswcz*mta*(1d0/4/ctw**4*vpaup*vpatn/ts/us*mw**2+1d0
     & /4/ctw**4*vpaup*vpatn/us**2*mw**2+1d0/4/ctw**4*vpadn*vpata/us**2*
     & mw**2-1d0/4/ctw**2*vpaup*vpatn*ts/us**2+1d0/4/ctw**2*vpaup*vpatn/
     & us**2*mw**2+1d0/4/ctw**2*vpaup*vmata/ts+1d0/4/ctw**2*vpadn*vpata/
     & ts/us*mw**2-1d0/4/ctw**2*vpadn*vpata*ts/us**2+1d0/4/ctw**2*vpadn*
     & vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vmata/us)
     & +propiwqs*c0ccqswcz*mta**3*(1d0/4/ctw**4*vpaup*vpatn/ts/us**2*mw*
     & *2-1d0/4/ctw**2*vpaup*vpatn/us**2+1d0/4/ctw**2*vpaup*vmata/ts/us+
     & 1d0/4/ctw**2*vpadn*vpata/ts/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/
     & ts/us-1d0/2/ctw**2*vpadn*vpata/us**2)
     & +propiwqs*c0ccqswcz*mta**5*(-1d0/4/ctw**2*vpadn*vpata/ts/us**2)
     & +propiwqs*c0cctscwta*mta*(-1d0/4/ctw**4*vpadn*vpata/qs/us*mw**2-1
     & d0/4/ctw**4*vpadn*vpata/us**2*mw**2-1d0/4/ctw**2*vpadn*vpata/qs+1
     & d0/4/ctw**2*vpadn*vpata*ts/us**2-1d0/4/ctw**2*vpadn*vpata/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpata/us+1d0/4/ctw**2*vpadn*vmata/qs+1d0/
     & 4/ctw**2*vpadn*vmata/us-ctw**2*qdn*qta*ts/us**2+ctw**2*qdn*qta/us
     & **2*mw**2+qdn*qta*ts/us**2-qdn*qta/us**2*mw**2)
     & +propiwqs*c0cctscwta*mta**3*(-1d0/4/ctw**4*vpadn*vpata/qs/us**2*m
     & w**2-1d0/4/ctw**2*vpadn*vpata/qs/us+1d0/4/ctw**2*vpadn*vpata/us**
     & 2+1d0/4/ctw**2*vpadn*vmata/qs/us-ctw**2*qdn*qta/us**2+qdn*qta/us*
     & *2)
     & +propiwqs*c0cctsczc*mta*(-1d0/4/ctw**4*vpaup*vpatn/us**2*mw**2-1d
     & 0/4/ctw**2*vpaup*vpatn/qs/us*mw**2-1d0/4/ctw**2*vpaup*vpatn/qs+1d
     & 0/4/ctw**2*vpaup*vpatn*ts/us**2-1d0/4/ctw**2*vpaup*vpatn/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpatn/us)
     & +propiwqs*c0cctsczc*mta**3*(-1d0/4/ctw**2*vpaup*vpatn/qs/us**2*mw
     & **2-1d0/4/ctw**2*vpaup*vpatn/qs/us)
     & +propiwqs*c0ccuscwta*mta*(1d0/4/ctw**2*vpaup*vmata/qs-1d0/4/ctw**
     & 2*vpaup*vmata/ts-ctw**2*qup*qta/qs+ctw**2*qup*qta/ts+qup*qta/qs-q
     & up*qta/ts)
     & +propiwqs*a0fta*mta*(stw**2*qdn*qta/ts/us)
     & +propiwqs*b0ftawc*mta*(-1d0/4/ctw**2*vpaup*vpatn/ts/us)
     & +propiwqs*b0ftazta*mta*(-1d0/4/ctw**2*vpadn*vpata/ts/us)
     & +propiwqs*b0fqswz*mta*(1d0/4/ctw**2*vpaup*vpatn/ts/us+1d0/4/ctw**
     & 2*vpadn*vpata/ts/us)
     & +propiwqs*b0fqswc*mta*(-ctw**2*qdn*qta/ts/us+qdn*qta/ts/us)
     & +sdet3ictaqs*mta*(-1d0/4/ctw**2*vpatn*vpata+ctw**2*qta-qta+1d0/2*
     & vpatn-1d0/2*vpata)
     & +sdet3ictaqs*mta**3*(-1d0/8*vpata/mw**2+1d0/8*vmata/mw**2+1d0/8/m
     & w**2)
     & +sdet3ictaqs**2*mta*(-2*ctw**2*qta*mw**2+2*qta*mw**2)
     & +sdet3ictaqs**2*mta**3*(8*ctw**2*qta-8*qta)
     & +sdet3ictaqs**3*mta**3*(6*ctw**2*qta*mw**2-6*qta*mw**2)
     & +sdet3ictaqs**3*mta**5*(-6*ctw**2*qta+6*qta)
     & +sdet3ictaqs**3*c0tacqswcz*mta**3*(-3/ctw**4*vpatn*mw**4)
     & +sdet3ictaqs**3*c0tacqsztaw*mta**3*(3*vpata*mw**4)
     & +sdet3ictaqs**3*c0tacqsztaw*mta**5*(-21d0/4*vpata*mw**2-3d0/4*vma
     & ta*mw**2)
     & +sdet3ictaqs**3*c0tacqsztaw*mta**7*(3d0/2*vpata+3d0/2*vmata)
     & +sdet3ictaqs**3*c0tacqsztaw*mta**9*(3d0/4*vpata/mw**2-3d0/4*vmata
     & /mw**2)
     & +sdet3ictaqs**3*c0tacqshtaw*mta**5*(-3d0/4*mw**2)
     & +sdet3ictaqs**3*c0tacqshtaw*mta**7*(3d0/2)
     & +sdet3ictaqs**3*c0tacqshtaw*mta**9*(-3d0/4/mw**2)
     & +sdet3ictaqs**3*c0tacqstazc*mta**3*(3d0/2/ctw**6*vpatn*vpata*mw**
     & 4)
     & +sdet3ictaqs**3*c0tacqsctaw*mta**3*(-6*stw**2*mw**4)
     & +sdet3ictaqs**3*c0tacqsctaw*mta**5*(12*stw**2*mw**2)
     & +sdet3ictaqs**3*c0tacqsctaw*mta**7*(-6*stw**2)
     & +sdet3ictaqs**3*a0fta*mta**3*(6*stw**2*qta*mw**2)
     & +sdet3ictaqs**3*a0fta*mta**5*(-6*stw**2*qta)
     & +sdet3ictaqs**3*b0ftawc*mta**3*(3/ctw**2*vpatn*mw**2)
     & +sdet3ictaqs**3*b0ftazta*mta**3*(3d0/2/ctw**4*vpatn*vpata*mw**2-3
     & *vpata*mw**2)
     & +sdet3ictaqs**3*b0ftazta*mta**5*(9d0/4*vpata+3d0/4*vmata)
     & +sdet3ictaqs**3*b0ftazta*mta**7*(3d0/4*vpata/mw**2-3d0/4*vmata/mw
     & **2)
     & +sdet3ictaqs**3*b0ftahta*mta**5*(3d0/4)
     & +sdet3ictaqs**3*b0ftahta*mta**7*(-3d0/4/mw**2)
     & +sdet3ictaqs**3*b0fqswz*mta**3*(-3/ctw**2*vpatn*mw**2+3*vpata*mw*
     & *2)
     & +sdet3ictaqs**3*b0fqswz*mta**5*(-9d0/4*vpata-3d0/4*vmata)
     & +sdet3ictaqs**3*b0fqswz*mta**7*(-3d0/4*vpata/mw**2+3d0/4*vmata/mw
     & **2)
     & +sdet3ictaqs**3*b0fqswh*mta**5*(-3d0/4)
     & +sdet3ictaqs**3*b0fqswh*mta**7*(3d0/4/mw**2)
     & +sdet3ictaqs**3*b0fqswc*mta**3*(-6*ctw**2*qta*mw**2+6*qta*mw**2)
     & +sdet3ictaqs**3*b0fqswc*mta**5*(6*ctw**2*qta-6*qta)
     & +sdet3ictaqs**3*b0fqstac*mta**3*(-3d0/2/ctw**4*vpatn*vpata*mw**2)
     & +sdet3ictaqs**2*c0tacqswcz*mta*(1d0/ctw**4*vpatn*mw**4+2/ctw**2*v
     & patn*mw**4)
     & +sdet3ictaqs**2*c0tacqswcz*mta**3*(1d0/ctw**4*vpatn*mw**2-2/ctw**
     & 2*vpatn*mw**2)
     & +sdet3ictaqs**2*c0tacqsztaw*mta*(-2/ctw**2*vpata*mw**4-vpata*mw**
     & 4)
     & +sdet3ictaqs**2*c0tacqsztaw*mta**3*(3d0/2/ctw**2*vpata*mw**2+1d0/
     & 2/ctw**2*vmata*mw**2+19d0/4*vpata*mw**2+13d0/4*vmata*mw**2)
     & +sdet3ictaqs**2*c0tacqsztaw*mta**5*(1d0/2/ctw**2*vpata-1d0/2/ctw*
     & *2*vmata-2*vpata-5*vmata)
     & +sdet3ictaqs**2*c0tacqsztaw*mta**7*(-7d0/4*vpata/mw**2+7d0/4*vmat
     & a/mw**2)
     & +sdet3ictaqs**2*c0tacqshtaw*mta**3*(-3d0/4*mw**2+1d0/2*mh**2)
     & +sdet3ictaqs**2*c0tacqshtaw*mta**5*(-1d0/2/mw**2*mh**2)
     & +sdet3ictaqs**2*c0tacqshtaw*mta**7*(3d0/4/mw**2)
     & +sdet3ictaqs**2*c0tacqstazc*mta*(-3d0/2/ctw**6*vpatn*vpata*mw**4)
     & +sdet3ictaqs**2*c0tacqstazc*mta**3*(-1d0/ctw**4*vpatn*vpata*mw**2
     & +1d0/ctw**4*vpatn*vmata*mw**2)
     & +sdet3ictaqs**2*c0tacqsctaw*mta*(2*stw**2*mw**4)
     & +sdet3ictaqs**2*c0tacqsctaw*mta**3*(-16*stw**2*mw**2)
     & +sdet3ictaqs**2*c0tacqsctaw*mta**5*(14*stw**2)
     & +sdet3ictaqs**2*a0fw*mta*(3*ctw**2*qta*mw**2-3*qta*mw**2-3d0/2*vp
     & ata*mw**2)
     & +sdet3ictaqs**2*a0fw*mta**3*(3d0/8-3d0/8*vpata+3d0/8*vmata)
     & +sdet3ictaqs**2*a0fz*mta*(3d0/4/ctw**4*vpatn*vpata*mw**2+3d0/2/ct
     & w**2*vpatn*mw**2)
     & +sdet3ictaqs**2*a0fta*mta*(-2*stw**2*qta*mw**2)
     & +sdet3ictaqs**2*a0fta*mta**3*(11*stw**2*qta+3d0/2*vpata)
     & +sdet3ictaqs**2*a0fta*mta**5*(3d0/8*vpata/mw**2-3d0/8*vmata/mw**2
     & -3d0/8/mw**2)
     & +sdet3ictaqs**2*b0ftawc*mta*(-1d0/ctw**2*vpatn*mw**2-1d0/2*vpatn*
     & mw**2)
     & +sdet3ictaqs**2*b0ftawc*mta**3*(-1d0/ctw**2*vpatn+1d0/2*vpatn)
     & +sdet3ictaqs**2*b0ftazta*mta*(-3d0/4/ctw**4*vpatn*vpata*mw**2+1d0
     & /2/ctw**2*vpata*mw**2+vpata*mw**2)
     & +sdet3ictaqs**2*b0ftazta*mta**3*(-1d0/ctw**2*vpatn*vpata+1d0/ctw*
     & *2*vpatn*vmata+1d0/8/ctw**2*vpata-1d0/8/ctw**2*vmata-3d0/4*vpata-
     & 13d0/4*vmata)
     & +sdet3ictaqs**2*b0ftazta*mta**5*(-vpata/mw**2+vmata/mw**2)
     & +sdet3ictaqs**2*b0ftahta*mta**3*(3d0/4-1d0/8/mw**2*mh**2)
     & +sdet3ictaqs**2*b0fqswz*mta*(5d0/2/ctw**2*vpatn*mw**2-1d0/2/ctw**
     & 2*vpata*mw**2+1d0/2*vpatn*mw**2-5d0/2*vpata*mw**2)
     & +sdet3ictaqs**2*b0fqswz*mta**3*(1d0/ctw**2*vpatn-1d0/8/ctw**2*vpa
     & ta+1d0/8/ctw**2*vmata-1d0/2*vpatn+15d0/8*vpata+29d0/8*vmata)
     & +sdet3ictaqs**2*b0fqswz*mta**5*(11d0/8*vpata/mw**2-11d0/8*vmata/m
     & w**2)
     & +sdet3ictaqs**2*b0fqswh*mta**3*(-3d0/8+1d0/8/mw**2*mh**2)
     & +sdet3ictaqs**2*b0fqswh*mta**5*(-3d0/8/mw**2)
     & +sdet3ictaqs**2*b0fqswc*mta*(5*ctw**2*qta*mw**2-5*qta*mw**2)
     & +sdet3ictaqs**2*b0fqswc*mta**3*(-11*ctw**2*qta+11*qta)
     & +sdet3ictaqs**2*b0fqstac*mta*(3d0/2/ctw**4*vpatn*vpata*mw**2)
     & +sdet3ictaqs**2*b0fqstac*mta**3*(1d0/ctw**2*vpatn*vpata-1d0/ctw**
     & 2*vpatn*vmata)
     & +sdet3ictaqs*c0tacqswcz*mta*(-1d0/2/ctw**2*vpatn*mw**2)
     & +sdet3ictaqs*c0tacqswcz*mta**3*(1d0/2/ctw**2*vpatn)
     & +sdet3ictaqs*c0tacqsztaw*mta*(1d0/2/ctw**2*vpata*mw**2-2/ctw**2*v
     & mata*mw**2-vmata*mw**2)
     & +sdet3ictaqs*c0tacqsztaw*mta**3*(-1d0/4/ctw**2*vpata+3d0/4/ctw**2
     & *vmata-1d0/2*vpata+9d0/2*vmata)
     & +sdet3ictaqs*c0tacqsztaw*mta**5*(5d0/4*vpata/mw**2-5d0/4*vmata/mw
     & **2)
     & +sdet3ictaqs*c0tacqshtaw*mta*(1d0/2*mh**2)
     & +sdet3ictaqs*c0tacqshtaw*mta**3*(-1-1d0/4/mw**2*mh**2)
     & +sdet3ictaqs*c0tacqshtaw*mta**5*(1d0/4/mw**2)
     & +sdet3ictaqs*c0tacqstazc*mta*(2/ctw**4*vpatn*vpata*mw**2-1d0/ctw*
     & *4*vpatn*vmata*mw**2)
     & +sdet3ictaqs*c0tacqsctaw*mta*(-stw**2*qdn/ts*mw**4+stw**2*qdn/us*
     & mw**4+2*stw**2*mw**2)
     & +sdet3ictaqs*c0tacqsctaw*mta**3*(2*stw**2*qdn/ts*mw**2-2*stw**2*q
     & dn/us*mw**2-8*stw**2)
     & +sdet3ictaqs*c0tacqsctaw*mta**5*(-stw**2*qdn/ts+stw**2*qdn/us)
     & +sdet3ictaqs*a0fw/mta*(-1d0/2*vpatn*mw**2)
     & +sdet3ictaqs*a0fw*mta*(1d0/4+1d0/4*vpata-1d0/4*vmata+1d0/4*invfta
     & w+2*invftaw*ctw**2*qta-2*invftaw*qta+1d0/4*invftaw*vpata-5d0/4*in
     & vftaw*vmata)
     & +sdet3ictaqs*a0fz/mta*(-1d0/4/ctw**4*vpatn*vpata*mw**2+1d0/2/ctw*
     & *2*vpata*mw**2)
     & +sdet3ictaqs*a0fz*mta*(-1d0/2/ctw**2*vpatn*vpata+1d0/2/ctw**2*vpa
     & tn*vmata-1d0/2/ctw**2*vpatn+1d0/8/ctw**2*vpata-1d0/8/ctw**2*vmata
     & )
     & +sdet3ictaqs*a0fh*mta*(-1d0/8/mw**2*mh**2)
     & +sdet3ictaqs*a0fta*mta*(-stw**2*qta+1d0/4/ctw**2*vpatn*vpata-1d0/
     & 2*vpata)
     & +sdet3ictaqs*a0fta*mta**3*(-3d0/8*vpata/mw**2+3d0/8*vmata/mw**2-1
     & d0/8/mw**2+2*invftaw*stw**2*qta/mw**2-1d0/4*invftaw*vpata/mw**2+5
     & d0/4*invftaw*vmata/mw**2-1d0/4*invftaw/mw**2)
     & +sdet3ictaqs*b0ftawc/mta*(-1d0/2*vpatn*mw**2)
     & +sdet3ictaqs*b0ftawc*mta*(1d0/2*vpatn)
     & +sdet3ictaqs*b0ftazta/mta*(-1d0/4/ctw**4*vpatn*vpata*mw**2+1d0/2/
     & ctw**2*vpata*mw**2)
     & +sdet3ictaqs*b0ftazta*mta*(1d0/ctw**2*vpatn*vpata-1d0/2/ctw**2*vp
     & atn*vmata+1d0/8/ctw**2*vpata+3d0/8/ctw**2*vmata-vpata+vmata)
     & +sdet3ictaqs*b0ftazta*mta**3*(1d0/4*vpata/mw**2-1d0/4*vmata/mw**2
     & )
     & +sdet3ictaqs*b0ftahta*mta*(-1d0/8/mw**2*mh**2)
     & +sdet3ictaqs*b0ftahta*mta**3*(1d0/4/mw**2)
     & +sdet3ictaqs*b0fqswz*mta*(-1d0/2/ctw**2*vpatn-1d0/2/ctw**2*vmata-
     & 1d0/2*vpatn+vpata-5d0/2*vmata)
     & +sdet3ictaqs*b0fqswz*mta**3*(-5d0/8*vpata/mw**2+5d0/8*vmata/mw**2
     & )
     & +sdet3ictaqs*b0fqswh*mta*(1d0/2)
     & +sdet3ictaqs*b0fqswh*mta**3*(-3d0/8/mw**2)
     & +sdet3ictaqs*b0fqswc*mta*(3*ctw**2*qta-3*qta)
     & +sdet3ictaqs*b0fqstac*mta*(-5d0/4/ctw**2*vpatn*vpata+1d0/ctw**2*v
     & patn*vmata)
     & +sdet3ictats*c0tacqsctaw*mta*(stw**2*qdn/us*mw**4-stw**2*qdn*mw**
     & 2)
     & +sdet3ictats*c0tacqsctaw*mta**3*(stw**2*qdn/ts/us*mw**4-stw**2*qd
     & n/ts*mw**2-2*stw**2*qdn/us*mw**2+stw**2*qdn)
     & +sdet3ictats*c0tacqsctaw*mta**5*(-2*stw**2*qdn/ts/us*mw**2+stw**2
     & *qdn/ts+stw**2*qdn/us)
     & +sdet3ictats*c0tacqsctaw*mta**7*(stw**2*qdn/ts/us)
     & +sdet3ictaus*c0tacqsctaw*mta**3*(-stw**2*qdn/qs*mw**2-stw**2*qdn-
     & stw**2/qs*mw**2-stw**2)
     & +sdet3ictaus*c0tacqsctaw*mta**5*(-stw**2*qdn/qs/us*mw**2-stw**2*q
     & dn/us-stw**2/qs/us*mw**2-stw**2/us)
     & +javsubqstsctaw*mta*(-2*ctw**2*qdn*qta*ts/us**2*mw**2+ctw**2*qdn*
     & qta*ts/us+ctw**2*qdn*qta*ts**2/us**2+ctw**2*qdn*qta/us**2*mw**4-c
     & tw**2*qdn*qta/us*mw**2+2*qdn*qta*ts/us**2*mw**2-qdn*qta*ts/us-qdn
     & *qta*ts**2/us**2-qdn*qta/us**2*mw**4+qdn*qta/us*mw**2)
     & +javsubqstsctaw*mta**3*(ctw**2*qdn*qta/ts/us**2*mw**4-ctw**2*qdn*
     & qta/ts/us*mw**2+3*ctw**2*qdn*qta*ts/us**2-4*ctw**2*qdn*qta/us**2*
     & mw**2+2*ctw**2*qdn*qta/us-qdn*qta/ts/us**2*mw**4+qdn*qta/ts/us*mw
     & **2-3*qdn*qta*ts/us**2+4*qdn*qta/us**2*mw**2-2*qdn*qta/us)
     & +javsubqstsctaw*mta**5*(-2*ctw**2*qdn*qta/ts/us**2*mw**2+ctw**2*q
     & dn*qta/ts/us+3*ctw**2*qdn*qta/us**2+2*qdn*qta/ts/us**2*mw**2-qdn*
     & qta/ts/us-3*qdn*qta/us**2)
     & +javsubqstsctaw*mta**7*(ctw**2*qdn*qta/ts/us**2-qdn*qta/ts/us**2)
     & +javsubqsusctaw*mta*(ctw**2*qup*qta/qs*mw**2-ctw**2*qup*qta/ts*us
     & +ctw**2*qup*qta/ts*mw**2-qup*qta/qs*mw**2+qup*qta/ts*us-qup*qta/t
     & s*mw**2)
     & +javsubqsusctaw*mta**3*(ctw**2*qup*qta/qs/us*mw**2+ctw**2*qup*qta
     & /ts/us*mw**2-2*ctw**2*qup*qta/ts-qup*qta/qs/us*mw**2-qup*qta/ts/u
     & s*mw**2+2*qup*qta/ts)
     & +javsubqsusctaw*mta**5*(-ctw**2*qup*qta/ts/us+qup*qta/ts/us)
     & +c0tacqsztaw*mta**3*(-1d0/4*vpata/mw**2+1d0/4*vmata/mw**2)
     & +c0tacqshtaw*mta**3*(-1d0/4/mw**2)
     & +c0tacqstazc*mta*(-1d0/2/ctw**2*vpatn*vpata+1d0/2/ctw**2*vpatn*vm
     & ata)
     & +c0tacqsctaw*mta*(-stw**2*qdn/ts*mw**2)
     & +c0tacqsctaw*mta**3*(-stw**2*qdn/qs/us*mw**2+stw**2*qdn/ts-stw**2
     & *qdn/us-stw**2/qs/us*mw**2-stw**2/us)
     & +c0cctscwta*mta*(-2*ctw**2*qdn*qta*ts/us**2*mw**2+ctw**2*qdn*qta*
     & ts/us+ctw**2*qdn*qta*ts**2/us**2+ctw**2*qdn*qta/us**2*mw**4-ctw**
     & 2*qdn*qta/us*mw**2+2*qdn*qta*ts/us**2*mw**2-qdn*qta*ts/us-qdn*qta
     & *ts**2/us**2-qdn*qta/us**2*mw**4+qdn*qta/us*mw**2)
     & +c0cctscwta*mta**3*(ctw**2*qdn*qta/ts/us**2*mw**4-ctw**2*qdn*qta/
     & ts/us*mw**2+3*ctw**2*qdn*qta*ts/us**2-4*ctw**2*qdn*qta/us**2*mw**
     & 2+2*ctw**2*qdn*qta/us-qdn*qta/ts/us**2*mw**4+qdn*qta/ts/us*mw**2-
     & 3*qdn*qta*ts/us**2+4*qdn*qta/us**2*mw**2-2*qdn*qta/us)
     & +c0cctscwta*mta**5*(-2*ctw**2*qdn*qta/ts/us**2*mw**2+ctw**2*qdn*q
     & ta/ts/us+3*ctw**2*qdn*qta/us**2+2*qdn*qta/ts/us**2*mw**2-qdn*qta/
     & ts/us-3*qdn*qta/us**2)
     & +c0cctscwta*mta**7*(ctw**2*qdn*qta/ts/us**2-qdn*qta/ts/us**2)
     & +c0ccuscwta*mta*(ctw**2*qup*qta/qs*mw**2-ctw**2*qup*qta/ts*us+ctw
     & **2*qup*qta/ts*mw**2-qup*qta/qs*mw**2+qup*qta/ts*us-qup*qta/ts*mw
     & **2)
     & +c0ccuscwta*mta**3*(ctw**2*qup*qta/qs/us*mw**2+ctw**2*qup*qta/ts/
     & us*mw**2-2*ctw**2*qup*qta/ts-qup*qta/qs/us*mw**2-qup*qta/ts/us*mw
     & **2+2*qup*qta/ts)
     & +c0ccuscwta*mta**5*(-ctw**2*qup*qta/ts/us+qup*qta/ts/us)

      ffarray(1,1) = ff_ew_ll
      ffarray(1,2) = ff_ew_ld
      ffarray(1,3) = ff_ew_rd

      return
      end
